//##################################################################################################
//
//  Ceetron Desktop Components
//  Qt4Minimal
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "CeeCore/CoreComponent.h"
#include "CeeCore/Version.h"
#include "CeeVisualization/VisualizationComponent.h"
#include "CeeVisualization/OpenGLContextGroup.h"
#include "CeeGeometry/GeometryComponent.h"

#include "Q4MMainWindow.h"

#include <QApplication>

#include <locale.h>


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
int main(int argc, char *argv[])
{
    // Initialize the parts of Ceetron Desktop Components that we'll use.
    // Please contact support@ceetron.com if you don't have a valid license.
    unsigned int licenseKeyA = 0x00;    // Todo: Set by developer 
    unsigned int licenseKeyB = 0x00;    // Todo: Set by developer
    cee::PtrRef<cee::Instance> compInst = cee::CoreComponent::initialize(licenseKeyA, licenseKeyB);
    cee::vis::VisualizationComponent::initialize(compInst.get());
    cee::geo::GeometryComponent::initialize(compInst.get());

    QApplication app(argc, argv);

    // On Linux, Qt will use the system locale, force number formatting settings back to "C" locale
    setlocale(LC_NUMERIC,"C");

    QString verInfo = QString("CDC %1, Qt %2").arg(CEE_VERSION_STRING).arg(QT_VERSION_STR);

    cee::PtrRef<cee::vis::OpenGLContextGroup> contextGroup = cee::vis::VisualizationComponent::createOpenGLContextGroup();
    Q4MMainWindow window(contextGroup.get());
    window.setWindowTitle("Qt4Minimal " + verInfo);
    window.resize(1000, 800);
    window.show();

    app.exec();

    return EXIT_SUCCESS;
}
