//##################################################################################################
//
//  Ceetron Desktop Components
//  QtDemoApp
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include <QWidget>

#include "CeeCore/PtrRef.h"


namespace Ui {
class IsovolumesWidget;
}

namespace cee {
    namespace vis { class View; }
    namespace ug { class UnstructGridModel; }
}

class QModelIndex;
class QStringListModel;


//==================================================================================================
//
// 
//
//==================================================================================================
class IsovolumesWidget : public QWidget
{
    Q_OBJECT

public:
    IsovolumesWidget(QWidget* parent = 0, Qt::WindowFlags f = Qt::WindowFlags());
    virtual ~IsovolumesWidget();

    void setup(cee::vis::View* view, cee::ug::UnstructGridModel* model);
    void selectIsovolume(size_t isovolumeIndex);

signals:
    void selected();

private:
    void updatePanel();

private slots:
    void applySelection(const QModelIndex& current, const QModelIndex& previous);
    void addIsovolume();
    void removeIsovolume();
    void setIsovolumeVisible(bool show);
    void setIsoScalarResult(int index);
    void applyRange();
    void setMappedScalarResult(int index);
    void setMappedVectorResult(int index);

private:
    Ui::IsovolumesWidget*                   m_ui;

    QStringListModel*                       m_listModel;

    cee::PtrRef<cee::ug::UnstructGridModel> m_unstructModel;
    cee::PtrRef<cee::vis::View>             m_view;

    int                                     m_nextId;
};

