//##################################################################################################
//
//  Ceetron Desktop Components
//  QtDemoApp
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include <QWidget>

#include "CeeCore/PtrRef.h"


namespace Ui {
class ModelSpecificationWidget;
}

namespace cee {
    namespace vis { class View; }
    namespace ug { class UnstructGridModel; }
}


//==================================================================================================
//
// 
//
//==================================================================================================
class ModelSpecificationWidget : public QWidget
{
    Q_OBJECT

public:
    ModelSpecificationWidget(QWidget* parent = 0, Qt::WindowFlags f = Qt::WindowFlags());
    virtual ~ModelSpecificationWidget();

    void setup(cee::vis::View* view, cee::ug::UnstructGridModel* model);

private:
    void updatePanel();

private slots:
    void setState(int index);
    void setScalarResult(int index);
    void setVectorResult(int index);
    void setDisplacementResult(int index);

private:
    Ui::ModelSpecificationWidget*           m_ui;

    cee::PtrRef<cee::ug::UnstructGridModel> m_unstructModel;
    cee::PtrRef<cee::vis::View>             m_view;
};
