//##################################################################################################
//
//  Ceetron Desktop Components
//  QtDemoApp
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "MouseClickEventFilter.h"

#include <QEvent>
#include <QMouseEvent>


//==================================================================================================
//
// Mouse click filtering event to be installed on any QObject-based classes 
// not already emitting the clicked() signal
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool MouseClickEventFilter::eventFilter(QObject *obj, QEvent *event)
{
    QEvent::Type eventType = event->type();
    if (eventType == QEvent::MouseButtonRelease) 
    {
        Q_ASSERT(dynamic_cast<QMouseEvent*>(event));
        QMouseEvent* mouseEvent = static_cast<QMouseEvent*>(event);

        if (mouseEvent->button() == Qt::LeftButton)
        {
            emit clicked();
            return true;
        }
    }

    // Standard event processing
    return QObject::eventFilter(obj, event);
}
