//##################################################################################################
//
//  Ceetron Desktop Components
//  QtDemoApp
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include <QWidget>

#include "CeeCore/PtrRef.h"


namespace Ui {
class PartsWidget;
}

class MouseClickEventFilter;

namespace cee {
    namespace vis { class View; }
    namespace ug { class UnstructGridModel; }
}


class QModelIndex;
class QStandardItemModel;


//==================================================================================================
//
// 
//
//==================================================================================================
class PartsWidget : public QWidget
{
    Q_OBJECT

public:
    PartsWidget(QWidget* parent = 0, Qt::WindowFlags f = Qt::WindowFlags());
    virtual ~PartsWidget();

    void setup(cee::vis::View* view, cee::ug::UnstructGridModel* model);
    void selectPart(size_t geometryIndex, int partId);

signals:
    void selected();

private:
    void updatePanel();

private slots:
    void applySelection(const QModelIndex& current, const QModelIndex& previous);
    void setPartVisible(bool show);
    void setOpacity(int value);
    void setDrawStyle(int index);
    void selectFixedColor();
    void enableSmoothShading(bool enable);
    void showFringes(bool show);
    void showVectors(bool show);

private:

    Ui::PartsWidget*                        m_ui;

    QStandardItemModel*                     m_listModel;

    cee::PtrRef<cee::ug::UnstructGridModel> m_unstructModel;
    cee::PtrRef<cee::vis::View>             m_view;

    MouseClickEventFilter*                  m_mouseClickEventFilter;
};

