
TEMPLATE = app

greaterThan(QT_MAJOR_VERSION, 5) {
    QT += network opengl widgets openglwidgets
} else {
    QT += network opengl
}

INCLUDEPATH += . 
INCLUDEPATH += ../../../include
INCLUDEPATH += ../../../PlatformIntegration/Qt

SOURCES += AboutDialog.cpp 
SOURCES += AnimationWidget.cpp
SOURCES += CuttingPlanesWidget.cpp 
SOURCES += IsosurfacesWidget.cpp 
SOURCES += IsovolumesWidget.cpp 
SOURCES += main.cpp 
SOURCES += MainWindow.cpp 
SOURCES += ModelSpecificationWidget.cpp 
SOURCES += MouseClickEventFilter.cpp 
SOURCES += ParticleTracesWidget.cpp 
SOURCES += PartsWidget.cpp 
SOURCES += PlotWidget.cpp 
SOURCES += ReportWidget.cpp
SOURCES += ReportCaptureDialog.cpp
SOURCES += ScalarResultsWidget.cpp 
SOURCES += SendToCloudDialogs.cpp 
SOURCES += VectorResultsWidget.cpp 
SOURCES += ViewerWidget.cpp
SOURCES += ../../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidget.cpp

HEADERS += AboutDialog.h 
HEADERS += AnimationWidget.h 
HEADERS += CuttingPlanesWidget.h 
HEADERS += IsosurfacesWidget.h 
HEADERS += IsovolumesWidget.h 
HEADERS += MainWindow.h 
HEADERS += ModelSpecificationWidget.h 
HEADERS += MouseClickEventFilter.h 
HEADERS += ParticleTracesWidget.h 
HEADERS += PartsWidget.h 
HEADERS += PlotWidget.h 
HEADERS += ReportWidget.h
HEADERS += ReportCaptureDialog.h
HEADERS += ScalarResultsWidget.h 
HEADERS += SendToCloudDialogs.h
HEADERS += VectorResultsWidget.h 
HEADERS += ViewerWidget.h
HEADERS += ../../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidget.h
HEADERS += ../../../PlatformIntegration/Qt/ceeqtUtilsCore.h
HEADERS += ../../../PlatformIntegration/Qt/ceeqtUtilsGui.h

# Functions backend requires at least Qt 5.6
equals(QT_MAJOR_VERSION, 5):greaterThan(QT_MINOR_VERSION, 5) {
    SOURCES += ../../../PlatformIntegration/Qt/ceeqtOpenGLFunctionsBackend_qt5.cpp
    HEADERS += ../../../PlatformIntegration/Qt/ceeqtOpenGLFunctionsBackend_qt5.h
}
greaterThan(QT_MAJOR_VERSION, 5) {
    SOURCES += ../../../PlatformIntegration/Qt/ceeqtOpenGLFunctionsBackend_qt5.cpp
    HEADERS += ../../../PlatformIntegration/Qt/ceeqtOpenGLFunctionsBackend_qt5.h
}

FORMS += AboutDialog.ui 
FORMS += AnimationWidget.ui 
FORMS += CuttingPlanesWidget.ui 
FORMS += IsosurfacesWidget.ui 
FORMS += IsovolumesWidget.ui 
FORMS += MainWindow.ui 
FORMS += ModelSpecificationWidget.ui 
FORMS += ParticleTracesWidget.ui 
FORMS += PartsWidget.ui 
FORMS += PlotWidget.ui 
FORMS += ReportWidget.ui
FORMS += ReportCaptureDialog.ui
FORMS += ScalarResultsWidget.ui 
FORMS += VectorResultsWidget.ui

RESOURCES = ./res/QtDemoApp.qrc

# Currently this does not seem to work on VS2013
win32-msvc2010:RC_FILE = ./res/QtDemoApp.rc


# Set path to where the component libraries reside
CONFIG(debug, debug|release)   {
	win32 {
		LIBS += CeeCored.lib
		LIBS += CeeVisualizationd.lib
		LIBS += CeeUnstructGridd.lib
		LIBS += CeeExportd.lib 
		LIBS += CeeImportCaed.lib
		LIBS += CeeReportd.lib
		LIBS += CeePlot2dd.lib
		LIBS += opengl32.lib
		LIBS += glu32.lib
	}
	unix {
		LIBS += -lCeeExportd
		LIBS += -lCeeUnstructGridd
		LIBS += -lCeeVisualizationd
		LIBS += -lCeePlot2dd
		LIBS += -lCeeCored
		LIBS += -lCeeImportCaed
		LIBS += -lCeeReportd
		LIBS += -lz
	}

	CEE_LIBDIR = $${PWD}/../../../lib/Debug   
}
CONFIG(release, debug|release) { 
	win32 {
		LIBS += CeeCore.lib
		LIBS += CeeVisualization.lib
		LIBS += CeeUnstructGrid.lib
		LIBS += CeeExport.lib 
		LIBS += CeeImportCae.lib
		LIBS += CeeReport.lib
		LIBS += CeePlot2d.lib
		LIBS += opengl32.lib
		LIBS += glu32.lib
	}
	unix {
		LIBS += -lCeeExport
		LIBS += -lCeeUnstructGrid
		LIBS += -lCeeVisualization
		LIBS += -lCeePlot2d
		LIBS += -lCeeCore
		LIBS += -lCeeImportCae
		LIBS += -lCeeReport
		LIBS += -lz
	}

	CEE_LIBDIR = $${PWD}/../../../lib/Release 
}

win32 {
    CEE_LIBDIR ~= s,/,\\,g
}

# Add to the directory to QMAKE_LIBDIR
message("CEE_LIBDIR = $${CEE_LIBDIR}")
QMAKE_LIBDIR += $$CEE_LIBDIR

  
# On windows/VS, copy the component DLLs to the output directory
win32 {
    CONFIG(debug, debug|release)   { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" debug" }
    CONFIG(release, debug|release) { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" release" }
}

# On Linux either us rpath relative to executable and then copy .so files...
#unix:QMAKE_LFLAGS += "-Wl,-rpath,\'\$$ORIGIN/.\'"
#unix:QMAKE_LFLAGS += "-Wl,-rpath,\'\$$CEE_LIBDIR/../abaodb\'"
#unix:QMAKE_POST_LINK = "cp $${CEE_LIBDIR}/libCee*.so ."

# ...or insert full rpath (seems to work best with QtCreator)
unix:QMAKE_RPATHDIR += $$CEE_LIBDIR
unix:QMAKE_RPATHDIR += $$CEE_LIBDIR/../../ThirdParty/Abaqus
unix:QMAKE_RPATHDIR += $$CEE_LIBDIR/../../ThirdParty/Hyperworks

# Force writing of the above paths as RPATH instead of RUNPATH on newer versions of GCC
unix:QMAKE_LFLAGS += "-Wl,--disable-new-dtag"

DEFINES += CEE_USE_IMPORT_CAE

