//##################################################################################################
//
//  Ceetron Desktop Components
//  QtDemoApp
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include <QWidget>

#include "CeeCore/PtrRef.h"


namespace Ui {
class VectorResultsWidget;
}

class MouseClickEventFilter;

namespace cee {
    namespace vis { class View; }
    namespace ug { class UnstructGridModel; }
}


class QModelIndex;
class QStandardItemModel;


//==================================================================================================
//
// 
//
//==================================================================================================
class VectorResultsWidget : public QWidget
{
    Q_OBJECT

public:
    VectorResultsWidget(QWidget* parent = 0, Qt::WindowFlags f = Qt::WindowFlags());
    virtual ~VectorResultsWidget();

    void setup(cee::vis::View* view, cee::ug::UnstructGridModel* model);

private:
    void updatePanel();

private slots:
    void applySelection(const QModelIndex& index);
    void enableRelativeScaling(bool enable);
    void applyScaleFactor();
    void setColorMode(int index);
    void selectFixedColor();

private:
    Ui::VectorResultsWidget*                m_ui;

    QStandardItemModel*                     m_listModel;

    cee::PtrRef<cee::ug::UnstructGridModel> m_unstructModel;
    cee::PtrRef<cee::vis::View>             m_view;

    MouseClickEventFilter*                  m_mouseClickEventFilter;
};
