//##################################################################################################
//
//  Ceetron Desktop Components
//  QtReport
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include <QMainWindow>

#include "CeeCore/PtrRef.h"

#include "CeeUnstructGrid/UnstructGridModel.h"

#include "CeeReport/Snapshot.h"
#include "CeeReport/Repository.h"

#include "ceeqtViewerOpenGLWidgetDemo.h"

//==================================================================================================
//
// 
//
//==================================================================================================
class QRMainWindow : public QMainWindow
{
    Q_OBJECT

public:
    QRMainWindow(cee::vis::OpenGLContextGroup* contextGroup);
    ~QRMainWindow();

public slots:
    void    slotOpen();

    void    slotCreateImageWordReport();
    void    slotCreateVTFxWordReport();
    void    slotCreateTableWordReport();
    void    slotCreateChartWordReport();
    void    slotCreateGenericImageWordReport();
    void    slotCreateSampleWordReport();
    void    slotCreateImagePowerPointReport();
    void    slotCreateVTFxPowerPointReport();
    void    slotCreateTablePowerPointReport();
    void    slotCreateSamplePowerPointReport();
    void    slotCreateGenericImagePowerPointReport();
    void    slotCreateImageHtmlReport();
    void    slotCreateTableHtmlReport();
    void    slotCreateAllReports();

public:
    void openFile(const QString& fileName);

private:
    cee::PtrRef<cee::rep::Snapshot> createImageSnapshot();
    cee::PtrRef<cee::rep::Snapshot> createVTFxSnapshot();
    cee::PtrRef<cee::rep::Snapshot> createScalarTableSnapshot();
    cee::PtrRef<cee::rep::Snapshot> createChartSnapshot();

    void showReport(const cee::Str& reportName) const;

    cee::qt::ViewerOpenGLWidgetDemo*        m_viewer;
    cee::PtrRef<cee::ug::UnstructGridModel> m_unstructModel;
};

