//##################################################################################################
//
//  Ceetron Report
//  QtRepositoryManager
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2016, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include <QDialog>

#include "CeeCore/PtrRef.h"
#include "CeeCore/Str.h"
#include "CeeUnstructGrid/UnstructGridModel.h"
#include "CeeReport/Repository.h"

#include "ceeqtViewerOpenGLWidgetDemo.h"


namespace Ui {
    class QRMAddSituationDialog;
}

//==================================================================================================
//
// 
//
//==================================================================================================
class QRMAddSituationDialog : public QDialog, public cee::qt::ViewerOpenGLWidgetDemo::InitializationObserver
{
    Q_OBJECT

public:
    QRMAddSituationDialog(cee::vis::OpenGLContextGroup* contextGroup);
    ~QRMAddSituationDialog();

    void loadModel(const cee::Str& vtfxFileName);

protected slots:
    void slotAddAsImage();
    void slotAddAsVTFx();
    void slotAddAsTable();
    void slotAddAsChart();

private:
    virtual void onViewerOpenGLReady(cee::qt::ViewerOpenGLWidget* viewer);

signals:
    void acceptedSnapshot(cee::rep::Snapshot*);

private:
    Ui::QRMAddSituationDialog*              m_ui;
    cee::qt::ViewerOpenGLWidgetDemo*        m_viewer;
    cee::PtrRef<cee::ug::UnstructGridModel> m_unstructModel;
    cee::Str                                m_modelFileName;
};

