//##################################################################################################
//
//  Ceetron Report
//  QtReportRepositoryViewer
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "QRMListWidget.h"

#include <QUrl>

#include "CeeReport/Snapshot.h"

#include "ceeqtUtilsCore.h"


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
QRMListWidget::QRMListWidget(QWidget* parent)
: QListWidget(parent)
{
	setIconSize(QSize(48,64));
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
QRMListWidget::~QRMListWidget()
{

}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
void QRMListWidget::addListSnapshot(size_t snapshotIndex, const QImage& image, const QString& title)
{
    QRMSituationItem* pItem = new QRMSituationItem(snapshotIndex, image, title, this);

	addItem(pItem);
	scrollToItem(pItem);
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
const cee::rep::Repository* QRMListWidget::repository() const
{
    return m_repository.get();
}





//=================================================================================================================================
//
// QRMSituationItem
//
//=================================================================================================================================

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
QRMSituationItem::QRMSituationItem(size_t snapshotIndex, QImage icon, const QString& title, QRMListWidget* parent)
:   QListWidgetItem(parent),
    m_snapshotIndex(snapshotIndex)
{
    setIcon(QIcon(QPixmap::fromImage(icon)));
    setText(title);
    setSizeHint(QSize(-1, 42));
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
size_t QRMSituationItem::snapshotIndex() const
{
    return m_snapshotIndex;
}

