//##################################################################################################
//
//  Ceetron Report
//  QtReportRepositoryViewer
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include <QListView>
#include <QListWidget>
#include <QListWidgetItem>

#include "CeeCore/Str.h"
#include "CeeCore/PtrRef.h"
#include "CeeReport/Repository.h"

class QRMListWidget;


//=================================================================================================================================
//
// Class: QRMSituationItem 
//
//=================================================================================================================================
class QRMSituationItem : public QListWidgetItem
{
public:
    QRMSituationItem(size_t snapshotIndex, QImage icon, const QString& title, QRMListWidget* parent);

    size_t snapshotIndex() const;

private:
    size_t m_snapshotIndex;
};


//=================================================================================================================================
//
// Class: QRMListWidget
//
/// List view for listing snapshots. 
/// 
//=================================================================================================================================
class QRMListWidget : public QListWidget
{
	Q_OBJECT

public:
	QRMListWidget(QWidget* parent = 0);
	virtual ~QRMListWidget();

    void addListSnapshot(size_t snapshotIndex, const QImage& image, const QString& title);
    
    const cee::rep::Repository* repository() const;

private:
    cee::PtrRef<cee::rep::Repository> m_repository;
};

