
TEMPLATE = app

greaterThan(QT_MAJOR_VERSION, 5) {
    QT += core opengl network widgets openglwidgets
} else {
    QT += opengl network
}

INCLUDEPATH += . 
INCLUDEPATH += ../../../include
INCLUDEPATH += ../../../PlatformIntegration/Qt

SOURCES += QRMMain.cpp 
SOURCES += QRMMainWindow.cpp 
SOURCES += QRMListWidget.cpp
SOURCES += QRMAddSituationDialog.cpp
SOURCES += QRMSendToCloudDialogs.cpp
SOURCES += QRMSummaryDialog.cpp
SOURCES += ../../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidget.cpp
SOURCES += ../../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidgetDemo.cpp

HEADERS += QRMMainWindow.h 
HEADERS += QRMListWidget.h
HEADERS += QRMAddSituationDialog.h
HEADERS += QRMSendToCloudDialogs.h
HEADERS += QRMSummaryDialog.h
HEADERS += ../../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidget.h
HEADERS += ../../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidgetDemo.h

FORMS += QRMMainWindow.ui 
FORMS += QRMAddSituationDialog.ui
FORMS += QRMSummaryDialog.ui

RESOURCES = ./QtRepositoryManager.qrc

# Set path to where the component libraries reside
CONFIG(debug, debug|release)   { 
	win32 {
		LIBS += CeeCored.lib
		LIBS += CeeVisualizationd.lib
		LIBS += CeeExportd.lib 
		LIBS += CeeReportd.lib
		LIBS += CeeUnstructGridd.lib
		LIBS += opengl32.lib
		LIBS += glu32.lib
	}
	unix {
		LIBS += -lCeeCored
		LIBS += -lCeeVisualizationd
		LIBS += -lCeeExportd
		LIBS += -lCeeReportd
		LIBS += -lCeeUnstructGridd
	}

	CEE_LIBDIR = $${PWD}/../../../lib/Debug   
}
CONFIG(release, debug|release) { 
	win32 {
		LIBS += CeeCore.lib
		LIBS += CeeVisualization.lib
		LIBS += CeeExport.lib 
		LIBS += CeeReport.lib
		LIBS += CeeUnstructGrid.lib
		LIBS += opengl32.lib
		LIBS += glu32.lib
	}
	unix {
		LIBS += -lCeeCore
		LIBS += -lCeeVisualization
		LIBS += -lCeeExport 
		LIBS += -lCeeReport 
		LIBS += -lCeeUnstructGrid
	}

	CEE_LIBDIR = $${PWD}/../../../lib/Release 
}

win32 {
    CEE_LIBDIR ~= s,/,\\,g
}

# Add to the directory to QMAKE_LIBDIR
message("CEE_LIBDIR = $${CEE_LIBDIR}")
QMAKE_LIBDIR += $$CEE_LIBDIR

  
# On windows/VS, copy the component DLLs to the output directory
win32 {
    CONFIG(debug, debug|release)   { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" debug" }
    CONFIG(release, debug|release) { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" release" }
}

# Insert full rpath (seems to work best with QtCreator)
unix:QMAKE_RPATHDIR += $$CEE_LIBDIR


