//##################################################################################################
//
//  Ceetron Desktop Components
//  WxMinimal
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "WMApp.h"
#include "WMMainFrame.h"

#include "CeeCore/CoreComponent.h"
#include "CeeVisualization/VisualizationComponent.h"
#include "CeeGeometry/GeometryComponent.h"



//==================================================================================================
//
// 
//
//==================================================================================================

IMPLEMENT_APP(WMApp)

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
WMApp::WMApp()
{
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool WMApp::OnInit()
{
    if (!wxApp::OnInit())
    {
        return false;
    }

    m_compInst = cee::CoreComponent::initialize();
    cee::vis::VisualizationComponent::initialize(m_compInst.get());
    cee::geo::GeometryComponent::initialize(m_compInst.get());

    WMMainFrame* mainFrame = new WMMainFrame;
    mainFrame->SetSize(800, 600);
    mainFrame->Show(true);

    return true;
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
int WMApp::OnExit()
{
    int retVal = wxApp::OnExit();

    // This will remove the last reference to the component instance and delete the object
    wxASSERT(m_compInst->refCount() == 1);
    m_compInst = NULL;
    
    return retVal;
}
