//##################################################################################################
//
//  Ceetron Desktop Components
//  WxMultiView
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "WMVApp.h"
#include "WMVMainFrame.h"

#include "CeeCore/CoreComponent.h"
#include "CeeVisualization/VisualizationComponent.h"
#include "CeeGeometry/GeometryComponent.h"
#include "CeeUnstructGrid/UnstructGridComponent.h"



//==================================================================================================
//
// 
//
//==================================================================================================

IMPLEMENT_APP(WMVApp)

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
WMVApp::WMVApp()
{
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool WMVApp::OnInit()
{
    if (!wxApp::OnInit())
    {
        return false;
    }

    m_compInst = cee::CoreComponent::initialize();
    cee::vis::VisualizationComponent::initialize(m_compInst.get());
    cee::geo::GeometryComponent::initialize(m_compInst.get());
    cee::ug::UnstructGridComponent::initialize(m_compInst.get());

    WMVMainFrame* mainFrame = new WMVMainFrame;
    mainFrame->SetSize(800, 600);
    mainFrame->Show(true);

    return true;
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
int WMVApp::OnExit()
{
    int retVal = wxApp::OnExit();

    wxASSERT(m_compInst->refCount() == 1);
    m_compInst = NULL;
    
    return retVal;
}
