//##################################################################################################
//
//  Ceetron Desktop Components
//  WxMultiView
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "wx/frame.h"

#include "ceewxViewerCanvasDemo.h"

#include "CeeCore/PtrRef.h"
#include "CeeVisualization/View.h"

#include <vector> 



//==================================================================================================
//
// 
//
//==================================================================================================
class WMVMainFrame : public wxFrame
{

public:
    WMVMainFrame();

private:
    void    onShow(wxShowEvent&);
    void    onClose(wxCloseEvent&);

    void    onCreateNViewers(wxCommandEvent&);
    void    onCreateCylinderInFirstViewer(wxCommandEvent&);
    void    onDeleteAllViews(wxCommandEvent&);
    void    onDeleteAllViewers(wxCommandEvent&);
    void    onExit(wxCommandEvent&);
    void    onAbout(wxCommandEvent&);

    void    deleteViewers();
    void    createViewers(size_t numViewers);
    void    populateView_sphereAndBoxesHalo(cee::vis::View* view);
    void    populateView_unstructGridModel(cee::vis::View* view);
    void    populateView_cylinder(cee::vis::View* view);

private:
    cee::PtrRef<cee::vis::OpenGLContextGroup> m_contextGroup;
    std::vector<cee::wx::ViewerCanvasDemo*>   m_viewers;

    DECLARE_EVENT_TABLE()
};

