//##################################################################################################
//
//  Ceetron Desktop Components
//  Platform integration for Qt
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/OpenGLFunctionsBackend.h"
#include "CeeCore/PtrRef.h"

#ifdef WIN32
#pragma warning (push)
#if _MSC_VER <= 1600
#pragma warning (disable: 4481)
#endif
#endif

// Remove override keyword if not supported
#ifndef CEE_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif

class QOpenGLFunctions;
class QOpenGLFunctions_2_1;
class QOpenGLFunctions_3_0;
class QOpenGLFunctions_3_2_Core;


namespace cee {

class LogManager;

namespace qt {



//==================================================================================================
//
// 
//
//==================================================================================================
class OpenGLFunctionsBackend_qt53_deprecated : public cee::vis::OpenGLFunctionsBackend
{
public:
    OpenGLFunctionsBackend_qt53_deprecated();
    virtual ~OpenGLFunctionsBackend_qt53_deprecated();

    virtual bool                initializeBackend(cee::vis::OpenGLBackendInfo* backendInfo) override;

    // Baseline OpenGL 2.1
    virtual void                glDisable(cee::vis::GLenum cap) override;
    virtual void                glEnable(cee::vis::GLenum cap) override;
    virtual cee::vis::GLenum    glGetError() override;
    virtual cee::vis::GLboolean glIsEnabled(cee::vis::GLenum cap) override;
    virtual void                glGetIntegerv(cee::vis::GLenum pname, cee::vis::GLint* params) override;

    virtual void                glViewport(cee::vis::GLint x, cee::vis::GLint y, cee::vis::GLsizei width, cee::vis::GLsizei height) override;
    virtual void                glClearColor(cee::vis::GLclampf red, cee::vis::GLclampf green, cee::vis::GLclampf blue, cee::vis::GLclampf alpha) override;
    virtual void                glClearDepth(cee::vis::GLclampd depth) override;
    virtual void                glStencilMask(cee::vis::GLuint mask) override;
    virtual void                glClearStencil(cee::vis::GLint s) override;
    virtual void                glScissor(cee::vis::GLint x, cee::vis::GLint y, cee::vis::GLsizei width, cee::vis::GLsizei height) override;
    virtual void                glClear(cee::vis::GLbitfield mask) override;

    virtual void                glDrawBuffer(cee::vis::GLenum mode) override;
    virtual void                glDrawBuffers(cee::vis::GLsizei n, const cee::vis::GLenum* bufs) override;

    virtual void                glVertexAttribPointer(cee::vis::GLuint index, cee::vis::GLint size, cee::vis::GLenum type, cee::vis::GLboolean normalized, cee::vis::GLsizei stride, const cee::vis::GLvoid* pointer) override;
    virtual void                glEnableVertexAttribArray(cee::vis::GLuint index) override;
    virtual void                glDisableVertexAttribArray(cee::vis::GLuint index) override;

    virtual void                glDrawArrays(cee::vis::GLenum mode, cee::vis::GLint first, cee::vis::GLsizei count) override;
    virtual void                glDrawElements(cee::vis::GLenum mode, cee::vis::GLsizei count, cee::vis::GLenum type, const cee::vis::GLvoid* indices) override;
    virtual void                glDrawRangeElements(cee::vis::GLenum mode, cee::vis::GLuint start, cee::vis::GLuint end, cee::vis::GLsizei count, cee::vis::GLenum type, const cee::vis::GLvoid* indices) override;

    virtual void                glUniform1f(cee::vis::GLint location, cee::vis::GLfloat v0) override;
    virtual void                glUniform1i(cee::vis::GLint location, cee::vis::GLint v0) override;
    virtual void                glUniform1fv(cee::vis::GLint location, cee::vis::GLsizei count, const cee::vis::GLfloat* value) override;
    virtual void                glUniform1iv(cee::vis::GLint location, cee::vis::GLsizei count, const cee::vis::GLint* value) override;
    virtual void                glUniform2fv(cee::vis::GLint location, cee::vis::GLsizei count, const cee::vis::GLfloat* value) override;
    virtual void                glUniform3fv(cee::vis::GLint location, cee::vis::GLsizei count, const cee::vis::GLfloat* value) override;
    virtual void                glUniform4fv(cee::vis::GLint location, cee::vis::GLsizei count, const cee::vis::GLfloat* value) override;
    virtual void                glUniformMatrix3fv(cee::vis::GLint location, cee::vis::GLsizei count, cee::vis::GLboolean transpose, const cee::vis::GLfloat* value) override;
    virtual void                glUniformMatrix4fv(cee::vis::GLint location, cee::vis::GLsizei count, cee::vis::GLboolean transpose, const cee::vis::GLfloat* value) override;

    virtual void                glBindBuffer(cee::vis::GLenum target, cee::vis::GLuint buffer) override;
    virtual void                glGenBuffers(cee::vis::GLsizei n, cee::vis::GLuint* buffers) override;
    virtual void                glDeleteBuffers(cee::vis::GLsizei n, const cee::vis::GLuint* buffers) override;
    virtual void                glBufferData(cee::vis::GLenum target, cee::vis::GLsizeiptr size, const cee::vis::GLvoid* data, cee::vis::GLenum usage) override;

    virtual cee::vis::GLuint    glCreateShader(cee::vis::GLenum shaderType) override;
    virtual void                glDeleteShader(cee::vis::GLuint shader) override;
    virtual void                glShaderSource(cee::vis::GLuint shader, cee::vis::GLsizei count, const cee::vis::GLchar** string, const cee::vis::GLint* length) override;
    virtual void                glCompileShader(cee::vis::GLuint shader) override;
    virtual cee::vis::GLboolean glIsShader(cee::vis::GLuint shader) override;
    virtual void                glGetShaderInfoLog(cee::vis::GLuint shader, cee::vis::GLsizei maxLength, cee::vis::GLsizei* length, cee::vis::GLchar* infoLog) override;
    virtual void                glGetShaderiv(cee::vis::GLuint shader, cee::vis::GLenum pname, cee::vis::GLint* params) override;

    virtual cee::vis::GLuint    glCreateProgram() override;
    virtual void                glDeleteProgram(cee::vis::GLuint program) override;
    virtual void                glAttachShader(cee::vis::GLuint program, cee::vis::GLuint shader) override;
    virtual void                glLinkProgram(cee::vis::GLuint program) override;
    virtual void                glValidateProgram(cee::vis::GLuint program) override;
    virtual cee::vis::GLboolean glIsProgram(cee::vis::GLuint program) override;
    virtual void                glUseProgram(cee::vis::GLuint program) override;
    virtual void                glGetProgramInfoLog(cee::vis::GLuint program, cee::vis::GLsizei maxLength, cee::vis::GLsizei* length, cee::vis::GLchar* infoLog) override;
    virtual void                glGetProgramiv(cee::vis::GLuint program, cee::vis::GLenum pname, cee::vis::GLint* params) override;
    virtual cee::vis::GLint     glGetUniformLocation(cee::vis::GLuint program, const cee::vis::GLchar* name) override;
    virtual void                glGetActiveUniform(cee::vis::GLuint program, cee::vis::GLuint index, cee::vis::GLsizei bufSize, cee::vis::GLsizei* length, cee::vis::GLint* size, cee::vis::GLenum* type, cee::vis::GLchar* name) override;
    virtual cee::vis::GLint     glGetAttribLocation(cee::vis::GLuint program, const cee::vis::GLchar* name) override;
    virtual void                glBindAttribLocation(cee::vis::GLuint program, cee::vis::GLuint index, const cee::vis::GLchar* name) override;

    virtual void                glGenTextures(cee::vis::GLsizei n, cee::vis::GLuint* textures) override;
    virtual void                glDeleteTextures(cee::vis::GLsizei n, const cee::vis::GLuint* textures) override;
    virtual void                glTexImage2D(cee::vis::GLenum target, cee::vis::GLint level, cee::vis::GLint internalFormat, cee::vis::GLsizei width, cee::vis::GLsizei height, cee::vis::GLint border, cee::vis::GLenum format, cee::vis::GLenum type, const cee::vis::GLvoid* data) override;
    virtual void                glGenerateMipmap(cee::vis::GLenum target) override;
    virtual void                glTexParameteri(cee::vis::GLenum target, cee::vis::GLenum pname, cee::vis::GLint param) override;
    virtual void                glTexParameterfv(cee::vis::GLenum target, cee::vis::GLenum pname, const cee::vis::GLfloat* params) override;
    virtual void                glBindTexture(cee::vis::GLenum target, cee::vis::GLuint texture) override;
    virtual void                glActiveTexture(cee::vis::GLenum texture) override;

    virtual void                glReadPixels(cee::vis::GLint x, cee::vis::GLint y, cee::vis::GLsizei width, cee::vis::GLsizei height, cee::vis::GLenum format, cee::vis::GLenum type, cee::vis::GLvoid* data) override;
    virtual void                glPixelStorei(cee::vis::GLenum pname, cee::vis::GLint param) override;

    virtual void                glBlendFunc(cee::vis::GLenum sfactor, cee::vis::GLenum dfactor) override;
    virtual void                glBlendFuncSeparate(cee::vis::GLenum srcRGB, cee::vis::GLenum dstRGB, cee::vis::GLenum srcAlpha, cee::vis::GLenum dstAlpha) override;
    virtual void                glBlendEquation(cee::vis::GLenum mode) override;
    virtual void                glBlendEquationSeparate(cee::vis::GLenum modeRGB, cee::vis::GLenum modeAlpha) override;
    virtual void                glBlendColor(cee::vis::GLfloat red, cee::vis::GLfloat green, cee::vis::GLfloat blue, cee::vis::GLfloat alpha) override;

    virtual void                glDepthFunc(cee::vis::GLenum func) override;
    virtual void                glDepthMask(cee::vis::GLboolean flag) override;
    virtual void                glColorMask(cee::vis::GLboolean red, cee::vis::GLboolean green, cee::vis::GLboolean blue, cee::vis::GLboolean alpha) override;
    virtual void                glCullFace(cee::vis::GLenum mode) override;
    virtual void                glFrontFace(cee::vis::GLenum mode) override;
    virtual void                glLineWidth(cee::vis::GLfloat width) override;
    virtual void                glPointSize(cee::vis::GLfloat size) override;
    virtual void                glPointParameteri(cee::vis::GLenum pname, cee::vis::GLint param) override;
    virtual void                glPolygonMode(cee::vis::GLenum face, cee::vis::GLenum mode) override;
    virtual void                glPolygonOffset(cee::vis::GLfloat factor, cee::vis::GLfloat units) override;
    virtual void                glStencilFunc(cee::vis::GLenum func, cee::vis::GLint ref, cee::vis::GLuint mask) override;
    virtual void                glStencilOp(cee::vis::GLenum sfail, cee::vis::GLenum dpfail, cee::vis::GLenum dppass) override;

    // OpenGL3+ and extensions
    virtual void                glGenRenderbuffers(cee::vis::GLsizei n, cee::vis::GLuint* renderbuffers) override;
    virtual void                glDeleteRenderbuffers(cee::vis::GLsizei n, cee::vis::GLuint* renderbuffers) override;
    virtual void                glBindRenderbuffer(cee::vis::GLenum target, cee::vis::GLuint renderbuffer) override;
    virtual void                glRenderbufferStorage(cee::vis::GLenum target, cee::vis::GLenum internalformat, cee::vis::GLsizei width, cee::vis::GLsizei height) override;
    virtual void                glRenderbufferStorageMultisample(cee::vis::GLenum target, cee::vis::GLsizei samples, cee::vis::GLenum internalformat, cee::vis::GLsizei width, cee::vis::GLsizei height) override;

    virtual void                glGenFramebuffers(cee::vis::GLsizei n, cee::vis::GLuint* ids) override;
    virtual void                glDeleteFramebuffers(cee::vis::GLsizei n, cee::vis::GLuint* framebuffers) override;
    virtual void                glFramebufferRenderbuffer(cee::vis::GLenum target, cee::vis::GLenum attachment, cee::vis::GLenum renderbuffertarget, cee::vis::GLuint renderbuffer) override;
    virtual void                glFramebufferTexture2D(cee::vis::GLenum target, cee::vis::GLenum attachment, cee::vis::GLenum textarget, cee::vis::GLuint texture, cee::vis::GLint level) override;
    virtual void                glBindFramebuffer(cee::vis::GLenum target, cee::vis::GLuint framebuffer) override;
    virtual cee::vis::GLenum    glCheckFramebufferStatus(cee::vis::GLenum target) override;
    virtual void                glBlitFramebuffer(cee::vis::GLint srcX0, cee::vis::GLint srcY0, cee::vis::GLint srcX1, cee::vis::GLint srcY1, cee::vis::GLint dstX0, cee::vis::GLint dstY0, cee::vis::GLint dstX1, cee::vis::GLint dstY1, cee::vis::GLbitfield mask, cee::vis::GLenum filter) override;

    virtual void                glVertexAttribIPointer(cee::vis::GLuint index, cee::vis::GLint size, cee::vis::GLenum type, cee::vis::GLsizei stride, const cee::vis::GLvoid* pointer) override;

    virtual void                glTexImage2DMultisample(cee::vis::GLenum target, cee::vis::GLsizei samples, cee::vis::GLint internalformat, cee::vis::GLsizei width, cee::vis::GLsizei height, cee::vis::GLboolean fixedsamplelocations) override;

private:
    QOpenGLFunctions*                   m_qtFuncs;

    QOpenGLFunctions_2_1*               m_qtFuncs_21;
    QOpenGLFunctions_3_0*               m_qtFuncs_30;
    QOpenGLFunctions_3_2_Core*          m_qtFuncs_32c;

    const cee::Str                      m_loggerName;
    PtrRef<cee::LogManager>             m_logMgr;
};


} // namespace qt
} // namespace cee


#ifdef WIN32
#pragma warning (pop)
#endif


#ifdef CVF_LINUX
#undef override
#endif
