//##################################################################################################
//
//  Ceetron Desktop Components
//  Platform integration for Qt
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/ViewerUIFramework.h"
#include "CeeVisualization/View.h"
#include "CeeCore/PtrRef.h"
#include "CeeCore/LogManager.h"

#include <QGLWidget>

namespace cee {
namespace qt {



//==================================================================================================
//
// 
//
//==================================================================================================
class ViewerGLWidget : public QGLWidget, public vis::ViewerUIFramework
{
public:
    ViewerGLWidget(vis::OpenGLContextGroup* contextGroup, QWidget* parent, const QGLFormat& format = QGLFormat());
    ViewerGLWidget(vis::OpenGLContextGroup* contextGroup, QWidget* parent, ViewerGLWidget* shareWidget);
    virtual ~ViewerGLWidget();

    void            setView(vis::View* aView);
    vis::View*      view();

    void            logOpenGLInfo();

protected:
    virtual void    resizeGL(int width, int height);
    virtual void    paintGL();

private:
    virtual void            doRequestRedraw();
    virtual void            doRequestImmediateRedraw();
    virtual bool            doMakeCurrent();
    virtual bool            doIsCurrent();
    virtual unsigned int    doGetDefaultFramebufferObject();

private:
    PtrRef<vis::View>   m_view;
};


}
}
