//##################################################################################################
//
//  Ceetron Desktop Components
//  Platform integration for Qt
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/ViewerUIFramework.h"

#include <QPointer>

class QGraphicsView;
class QGLWidget;

namespace cee {
namespace qt {



//==================================================================================================
//
// 
//
//==================================================================================================
class ViewerGraphicsViewAdapter : public vis::ViewerUIFramework
{
public:
    ViewerGraphicsViewAdapter(vis::OpenGLContextGroup* contextGroup, QGraphicsView* graphicsView, QGLWidget* viewportGLWidget);
    virtual ~ViewerGraphicsViewAdapter();

private:
    virtual void            doRequestRedraw();
    virtual void            doRequestImmediateRedraw();
    virtual bool            doMakeCurrent();
    virtual bool            doIsCurrent();
    virtual unsigned int    doGetDefaultFramebufferObject();

private:
    QPointer<QGraphicsView>  m_graphicsView;
    QPointer<QGLWidget>      m_viewportGLWidget;
};



}
}

