//##################################################################################################
//
//  Ceetron Desktop Components
//  Platform integration for Qt
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "ceeqtViewerOpenGLWidget.h"

namespace cee {
namespace qt {



//==================================================================================================
//
// 
//
//==================================================================================================
class ViewerOpenGLWidgetDemo : public ViewerOpenGLWidget
{
public:
    class InitializationObserver
    {
    public:
        virtual void onViewerOpenGLReady(ViewerOpenGLWidget* viewer) = 0;
    };

public:
    ViewerOpenGLWidgetDemo(cee::vis::OpenGLContextGroup* contextGroup, QWidget* parent, InitializationObserver* initializationObserver = NULL);
    virtual ~ViewerOpenGLWidgetDemo();

protected:
    virtual void    mousePressEvent(QMouseEvent* event);
    virtual void    mouseMoveEvent(QMouseEvent* event);
    virtual void    mouseReleaseEvent(QMouseEvent* event);
    virtual void    wheelEvent(QWheelEvent* event);

private:
    virtual void    onViewerOpenGLReady();

private:
    InitializationObserver* m_initializationObserver;
};


}   // namespace qt
}   // namespace cee

