//##################################################################################################
//
//  Ceetron Desktop Components
//  Platform integration for WxWidgets
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "wx/glcanvas.h"

#include "CeeCore/PtrRef.h"

#include "CeeVisualization/ViewerUIFramework.h"
#include "CeeVisualization/View.h"

namespace cee {
namespace wx {



//==================================================================================================
//
// 
//
//==================================================================================================
class ViewerCanvas : public wxGLCanvas, public vis::ViewerUIFramework
{
public:
    ViewerCanvas(cee::vis::OpenGLContextGroup* contextGroup, wxWindow* parent, int* attribList);
    ViewerCanvas(cee::vis::OpenGLContextGroup* contextGroup, wxWindow* parent, int* attribList, ViewerCanvas* shareCanvas);
    ~ViewerCanvas();

    bool                    initializeViewer();
    void                    shutdownViewer();

    void                    setView(cee::vis::View* aView);
    cee::vis::View*         view();

private:
    virtual void            doRequestRedraw();
    virtual void            doRequestImmediateRedraw();
    virtual bool            doMakeCurrent();
    virtual bool            doIsCurrent();
    virtual unsigned int    doGetDefaultFramebufferObject();
    bool                    tryMakeGLContextCurrentForCanvas();

    void                    onPaint(wxPaintEvent& event);

private:
    bool                            m_viewerIsInitialized;
    bool                            m_viewerHasBeenShutdown;
    wxGLContext*                    m_wxGLContext;  
    cee::PtrRef<cee::vis::View>     m_view;

    DECLARE_EVENT_TABLE()
};

}
}

