//##################################################################################################
//
//  Ceetron Desktop Components
//  Tutorials
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#if MFC_TUTORIAL
#include "MfcTutorialRunner/TutorialRunnerMainWindow.h"
#elif WX_TUTORIAL
#include "WxTutorialRunner/TutorialRunnerMainWindow.h"
#else
#include "QtTutorialRunner/TutorialRunnerMainWindow.h"
#endif

#include "TutorialUtils.h"

#include "CeeVisualization/Font.h"
#include "CeeVisualization/Overlay.h"

#include "CeePlot2d/OverlayPlot.h"


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
void TutorialRunnerMainWindow::createPlot()
{
    //--------------------------------------------------------------------------
    // Create an overlay plot item and add two plot curves
    //--------------------------------------------------------------------------

    // X Values (same for both curves)
    double curvex[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0 };
    // Y Values
    double curve1y[] = { 0.0, 1.2, 3.3, 4.0, 3.0, 2.9, 2.8, 2.7, 2.7, 2.7 };
    double curve2y[] = { 0.0, 1.5, 4.3, 5.0, 4.0, 3.8, 3.5, 3.0, 2.8, 2.7 };

    std::vector<double> xValues(curvex, curvex + 10);
    std::vector<double> y1Values(curve1y, curve1y + 10);
    std::vector<double> y2Values(curve2y, curve2y + 10);

    cee::PtrRef<cee::vis::Font> font = cee::vis::Font::createNormalFont();
    cee::PtrRef<cee::plt::OverlayPlot> plot = new cee::plt::OverlayPlot(font.get());
    plot->setSize(400, 300);
    plot->addCurve("First curve", xValues, y1Values);
    plot->addCurve("Second curve", xValues, y2Values);

    cee::vis::View* gcView = getTutorialView();
    gcView->overlay().addItem(plot.get(), cee::vis::OverlayItem::TOP_RIGHT, cee::vis::OverlayItem::HORIZONTAL);
    gcView->requestRedraw();
}
