
TEMPLATE = app

greaterThan(QT_MAJOR_VERSION, 5) {
    QT += opengl widgets openglwidgets
} else {
    QT += opengl
}


INCLUDEPATH += . 
INCLUDEPATH += ../../include
INCLUDEPATH += ../../PlatformIntegration/Qt

CONFIG(debug, debug|release)   {
	win32 {
		LIBS += CeeCored.lib
		LIBS += CeeVisualizationd.lib
		LIBS += CeeGeometryd.lib 
		LIBS += CeeUnstructGridd.lib 
		LIBS += CeeReportd.lib
		LIBS += CeeExportd.lib
		LIBS += CeePlot2dd.lib
		LIBS += opengl32.lib
		LIBS += glu32.lib
	}
	unix {
		LIBS += -lCeeCored
		LIBS += -lCeeVisualizationd
		LIBS += -lCeeGeometryd
		LIBS += -lCeeUnstructGridd
		LIBS += -lCeeReportd
		LIBS += -lCeeExportd
		LIBS += -lCeePlot2dd
	}
}
CONFIG(release, debug|release) {
	win32 {
		LIBS += CeeCore.lib
		LIBS += CeeVisualization.lib
		LIBS += CeeGeometry.lib 
		LIBS += CeeUnstructGrid.lib 
		LIBS += CeeReport.lib
		LIBS += CeeExport.lib
		LIBS += CeePlot2d.lib
		LIBS += opengl32.lib
		LIBS += glu32.lib
	}
	unix {
		LIBS += -lCeeCore
		LIBS += -lCeeVisualization
		LIBS += -lCeeGeometry
		LIBS += -lCeeUnstructGrid 
		LIBS += -lCeeReport
		LIBS += -lCeeExport
		LIBS += -lCeePlot2d
	}
}

SOURCES += ../Animation.cpp
SOURCES += ../CustomDataReader.cpp
SOURCES += ../CustomNavigation.cpp
SOURCES += ../CuttingPlane.cpp
SOURCES += ../DataElementSets.cpp
SOURCES += ../GeometryModel.cpp
SOURCES += ../GeometryModelWithPrimitives.cpp
SOURCES += ../GeometryModelWithTexture.cpp
SOURCES += ../Highlighting.cpp
SOURCES += ../Isosurface.cpp
SOURCES += ../Isovolume.cpp
SOURCES += ../MarkupModel.cpp
SOURCES += ../PartSettings.cpp
SOURCES += ../Plot.cpp
SOURCES += ../Report.cpp 
SOURCES += ../ScalarSettings.cpp
SOURCES += ../SimpleLoadVTFx.cpp
SOURCES += ../Snippets.cpp
SOURCES += ../TutorialUtils.cpp
SOURCES += ../TutorialUtils.h
SOURCES += ../UnstructGridModel.cpp
SOURCES += ../UnstructGridModelResults.cpp
SOURCES += ../VectorSettings.cpp

SOURCES += TutorialRunnerMain.cpp
SOURCES += TutorialRunnerMainWindow.cpp
SOURCES += TutorialRunnerViewer.cpp

SOURCES += ../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidget.cpp

HEADERS += TutorialRunnerMainWindow.h
HEADERS += TutorialRunnerViewer.h
HEADERS += ../../PlatformIntegration/Qt/ceeqtViewerOpenGLWidget.h


# Set path to where the component libraries reside
win32 {
    CONFIG(debug, debug|release)   { CEE_LIBDIR = $${PWD}/../../lib/Debug   }
    CONFIG(release, debug|release) { CEE_LIBDIR = $${PWD}/../../lib/Release }
    CEE_LIBDIR ~= s,/,\\,g
}
unix {
    CONFIG(debug, debug|release)   { CEE_LIBDIR = $${PWD}/../../lib/Debug   }
    CONFIG(release, debug|release) { CEE_LIBDIR = $${PWD}/../../lib/Release }
}

# Add to the directory to QMAKE_LIBDIR
message("CEE_LIBDIR = $${CEE_LIBDIR}")
QMAKE_LIBDIR += $$CEE_LIBDIR

  
# On windows/VS, copy the component DLLs to the output directory
win32 {
    CONFIG(debug, debug|release)   { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" debug" }
    CONFIG(release, debug|release) { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" release" }
}

# Insert full rpath (seems to work best with QtCreator)
unix:QMAKE_RPATHDIR += $$CEE_LIBDIR


