//##################################################################################################
//
//  Ceetron Desktop Components
//  QtTutorialRunner
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "TutorialRunnerMainWindow.h"

#include "CeeCore/CoreComponent.h"
#include "CeeVisualization/VisualizationComponent.h"
#include "CeeVisualization/OpenGLContextGroup.h"
#include "CeeUnstructGrid/UnstructGridComponent.h"
#include "CeeGeometry/GeometryComponent.h"
#include "CeeReport/ReportComponent.h"
#include "CeePlot2d/Plot2dComponent.h"
#include "CeeExport/ExportComponent.h"

#include <QApplication>



//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
int main(int argc, char *argv[])
{
    // Initialize the parts of Ceetron Desktop Components that we'll use
    // Please contact support@ceetron.com if you don't have a valid license.
    unsigned int licenseKeyA = 0x00;    // Todo: Set by developer 
    unsigned int licenseKeyB = 0x00;    // Todo: Set by developer
    cee::PtrRef<cee::Instance> compInst = cee::CoreComponent::initialize(licenseKeyA, licenseKeyB);
    cee::vis::VisualizationComponent::initialize(compInst.get());
    cee::ug::UnstructGridComponent::initialize(compInst.get());
    cee::geo::GeometryComponent::initialize(compInst.get());
    cee::rep::ReportComponent::initialize(compInst.get());
    cee::exp::ExportComponent::initialize(compInst.get());
    cee::plt::Plot2dComponent::initialize(compInst.get());

    QApplication app(argc, argv);

    cee::PtrRef<cee::vis::OpenGLContextGroup> contextGroup = cee::vis::VisualizationComponent::createOpenGLContextGroup();
    TutorialRunnerMainWindow window(contextGroup.get());
    window.setWindowTitle("QtTutorialRunner");
    window.resize(1024, 768);
    window.show();

    app.exec();

    return EXIT_SUCCESS;
}
