//##################################################################################################
//
//  Ceetron Desktop Components
//  Tutorials
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "QtTutorialRunner/TutorialRunnerMainWindow.h"

#include "TutorialUtils.h"

#include "CeeVisualization/View.h"
#include "CeeVisualization/Camera.h"

#include "CeeUnstructGrid/UnstructGridModel.h"
#include "CeeUnstructGrid/DataState.h"
#include "CeeUnstructGrid/ModelSpec.h"
#include "CeeUnstructGrid/DataStateSpec.h"
#include "CeeUnstructGrid/DataSourceVTF.h"
#include "CeeUnstructGrid/HitItem.h"



//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
void TutorialRunnerMainWindow::snippets()
{
    // Create the model and data source
    cee::PtrRef<cee::ug::UnstructGridModel> ugModel = new cee::ug::UnstructGridModel();
    cee::PtrRef<cee::ug::DataSourceVTF> source = new cee::ug::DataSourceVTF(42);

    // Open the vtfx file
    cee::Str vtfxFile = TutorialUtils::testDataDir() + "contact.vtfx";
    if (!source->open(vtfxFile))
    {
        // VTFx file not found
        return;
    }

    // Add the data source to the model
    ugModel->setDataSource(source.get());


    // DataStateSpec
    //--------------------------------------------------------------------------

    // We want to load state with id 1 and scalar result with id 4.
    int scalarId = 4;
    int stateId = 1;

    // Create array of scalar result ids to be loaded
    std::vector<int> scalarIds(1);
    scalarIds[0] = scalarId;

    // Insert the scalar results to load into the state spec
    cee::ug::DataStateSpec stateSpec;
    stateSpec.setScalarResultIds(scalarIds);

    // Load the state with the requested state spec
    source->loadState(stateId, stateSpec, NULL);

    // DataGeometry
    //--------------------------------------------------------------------------

    //const cee::ug::DataState* state = source->state(0);
    //const cee::ug::DataGeometry* geometry = state->firstGeometry();

    // HitItem
    //--------------------------------------------------------------------------

    //int winCoordX = 0, winCoordY = 0;
    //cee::Ray ray = m_viewer->view()->camera().rayFromWindowCoordinates(winCoordX, winCoordY);
    //cee::ug::HitItem hitItem;
    //bool hitSomething = ugModel->rayIntersect(ray, &hitItem);
}
