//##################################################################################################
//
//  Ceetron Desktop Components
//  WxTutorialRunner
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#include "TutorialRunnerApp.h"
#include "TutorialRunnerMainWindow.h"

#include "CeeCore/CoreComponent.h"
#include "CeeVisualization/VisualizationComponent.h"
#include "CeeGeometry/GeometryComponent.h"
#include "CeeUnstructGrid/UnstructGridComponent.h"
#include "CeeReport/ReportComponent.h"
#include "CeeExport/ExportComponent.h"
#include "CeePlot2d/Plot2dComponent.h"

//==================================================================================================
//
// 
//
//==================================================================================================

IMPLEMENT_APP(ExampleApp)

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
ExampleApp::ExampleApp()
{
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool ExampleApp::OnInit()
{
    if (!wxApp::OnInit())
    {
        return false;
    }

    // Initialize the parts of Ceetron Desktop Components that we'll use
    m_compInst = cee::CoreComponent::initialize();
    cee::vis::VisualizationComponent::initialize(m_compInst.get());
    cee::geo::GeometryComponent::initialize(m_compInst.get());
    cee::ug::UnstructGridComponent::initialize(m_compInst.get());
    cee::rep::ReportComponent::initialize(m_compInst.get());
    cee::exp::ExportComponent::initialize(m_compInst.get());
    cee::plt::Plot2dComponent::initialize(m_compInst.get());

    TutorialRunnerMainWindow* mainWnd = new TutorialRunnerMainWindow;
    mainWnd->SetSize(700, 700);
    mainWnd->Show(true);

    return true;
}


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
int ExampleApp::OnExit()
{
    int retVal = wxApp::OnExit();

    wxASSERT(m_compInst->refCount() == 1);
    m_compInst = NULL;

    return retVal;
}
