//##################################################################################################
//
//  Ceetron Desktop Components
//  WxTutorialRunner
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "wx/event.h"

#include "CeeCore/PtrRef.h"
#include "CeeVisualization/MouseEvent.h"
#include "CeeVisualization/WheelEvent.h"
#include "CeeVisualization/MouseEvent.h"

#include "ceewxViewerCanvas.h"

class TutorialRunnerMainWindow;



//==================================================================================================
//
// 
//
//==================================================================================================
class TutorialRunnerViewerCanvas : public cee::wx::ViewerCanvas
{
public:
    TutorialRunnerViewerCanvas(cee::vis::OpenGLContextGroup* contextGroup, TutorialRunnerMainWindow* parentMainWindow, int* attribList);
    ~TutorialRunnerViewerCanvas();

private:
    void                                onMouseDown(wxMouseEvent& event);
    void                                onMouseReleased(wxMouseEvent& event);
    void                                onMouseMove(wxMouseEvent& event);
    void                                onMouseWheelMove(wxMouseEvent& event);

    cee::vis::MouseEvent                toMouseEvent(const wxMouseEvent& event);
    cee::vis::WheelEvent                toWheelEvent(const wxMouseEvent& event);
    static cee::vis::MouseButton        toMouseButton(const wxMouseEvent& event);
    static cee::vis::KeyboardModifiers  toKeyboardModifiers(const wxMouseEvent& event);

private:
    TutorialRunnerMainWindow*   m_mainWindow;
    bool                        m_cleanLeftButtonPressOccurred;
    wxPoint                     m_cleanLeftButtonPressPos;

    DECLARE_EVENT_TABLE()
};


