//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: App
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeApp/Base.h"
#include "CeeCore/Str.h"
#include "CeeUnstructGrid/UnstructGridModel.h"

namespace cee {

class Instance;

namespace app {


//==================================================================================================
//
// Static class for App component
//
//==================================================================================================
class CEE_APP_EXPORT AppComponent
{
public:
    static bool                 isInitialized();
    static bool                 initialize(Instance* instance);

    static unsigned int         version();
    static Str                  versionString();

    static void                 setProgressInstance(cee::ug::Progress* progress);
    static cee::ug::Progress*   progressInstance();


private:
    static cee::ug::Progress*   setGetProgressSingleton(bool set, cee::ug::Progress* progress);

    CEE_DISALLOW_COPY_AND_ASSIGN(AppComponent);
};


}
}
