//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: App
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeApp/Base.h"
#include "CeeCore/Base.h"
#include "CeeCore/PtrRef.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeUnstructGrid/HitItem.h"
#include "CeeVisualization/View.h"
#include "CeePlot2d/OverlayPlot.h"

#include <map>

namespace cee {
namespace ug {

class UnstructGridModel;

}
}

namespace cee {
namespace app {

//==================================================================================================
//
// Class for Plot management
//
//==================================================================================================
class CEE_APP_EXPORT Plots : public RefCountedObject
{

public:
    static Plots* instance();

    size_t count() const;

    size_t                   index(cee::plt::OverlayPlot* plot);
    cee::plt::OverlayPlot*   get(size_t index);
    cee::plt::OverlayPlot*   add();
    cee::plt::Curve*         addHistoryCurve(size_t plotIndex, const cee::ug::HitItem& hitItem, const cee::ug::UnstructGridModel* model, int scalarId);
    cee::plt::Curve*         addLengthCurve(size_t plotIndex, const cee::ug::UnstructGridModel* model, std::vector<cee::Vec3d>* pathPoints = NULL);

    bool                     remove(size_t index);
    void                     removeAll();
    
private:
    Plots();
    virtual ~Plots();


    CEE_PRIVATE_IMPL(Plots);
    CEE_DISALLOW_COPY_AND_ASSIGN(Plots);

};

} // namespace cee
} // namespace app
