//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: App
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeApp/Base.h"
#include "CeeCore/Base.h"
#include "CeeCore/PtrRef.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeUnstructGrid/DataState.h"
#include "CeeUnstructGrid/StateInfo.h"

namespace cee {
namespace app {


//==================================================================================================
//
// Class for View management
//
//==================================================================================================
class CEE_APP_EXPORT States : public RefCountedObject
{

public:

    static States*              instance();

    size_t                      count() const;

    cee::ug::DataState*         current();

    cee::ug::StateInfo          currentInfo() const;
    void                        setCurrentInfo(cee::ug::StateInfo info);

    size_t                      currentIndex() const;
    void                        setCurrentIndex(size_t index);

    size_t                      indexOf(cee::ug::StateInfo info) const;

    cee::ug::StateInfo          info(size_t index) const;
    cee::ug::StateInfo          info(const cee::Str& wildcard) const;


private:
    States();
    virtual ~States();

    CEE_PRIVATE_IMPL(States);
    CEE_DISALLOW_COPY_AND_ASSIGN(States);

};

} // namespace cee
} // namespace app
