//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

namespace cee {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT CodeLocation
{
public:
    CodeLocation();
    CodeLocation(const char* fileName, const char* functionName, int lineNumber);
    CodeLocation(const CodeLocation& other);

    const CodeLocation& operator=(CodeLocation rhs);

    const char*         fileName() const;
    const char*         shortFileName() const;
    const char*         functionName() const;
    int                 lineNumber() const;
    void                swap(CodeLocation& other);

private:
    const char*     m_fileName;
    const char*     m_functionName;
    int             m_lineNumber;
};

} // namespace cee


#if defined(_MSC_VER)
#define CEE_CODELOC_FUNCNAME __FUNCSIG__
#elif defined(__GNUC__)
#define CEE_CODELOC_FUNCNAME __PRETTY_FUNCTION__
#else
#define CEE_CODELOC_FUNCNAME ""
#endif

#define CEE_CODE_LOCATION ::cee::CodeLocation(__FILE__, CEE_CODELOC_FUNCNAME, __LINE__)


