//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"

namespace cee {


//==================================================================================================
//
// RGB float color
//
//==================================================================================================
class CEE_CORE_EXPORT Color3f 
{
public:
    Color3f();
    Color3f(const Color3f& other);
    Color3f(float r, float g, float b);

    Color3f&        operator=(const Color3f& rhs);

    bool            operator==(const Color3f& rhs) const;
    bool            operator!=(const Color3f& rhs) const;

    const float&    r() const;
    const float&    g() const;
    const float&    b() const;
    float&          r();
    float&          g();
    float&          b();

    bool            isValid() const;

private:
    float m_color[3];
};

} // namespace cee
