//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"

namespace cee {


//==================================================================================================
//
// RGB float color
//
//==================================================================================================
class CEE_CORE_EXPORT Color4f 
{
public:
    Color4f();
    Color4f(const Color4f& other);
    Color4f(float r, float g, float b, float a);

    Color4f&        operator=(const Color4f& rhs);

    bool            operator==(const Color4f& rhs) const;
    bool            operator!=(const Color4f& rhs) const;

    const float&    r() const;
    const float&    g() const;
    const float&    b() const;
    const float&    a() const;
    float&          r();
    float&          g();
    float&          b();
    float&          a();

    bool            isValid() const;

private:
    float m_color[4];
};

} // namespace cee
