//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/Instance.h"
#include "CeeCore/PtrRef.h"
#include "CeeCore/InitializationOptions.h"

#include <string>

namespace cee {

class LogManager;


//==================================================================================================
//
// Static class for Core component
//
//==================================================================================================
class CEE_CORE_EXPORT CoreComponent
{
public:
    static bool             isInitialized();
    static PtrRef<Instance> initialize(unsigned int licenseKeyA, unsigned int licenseKeyB, const InitializationOptions& initializationOptions = InitializationOptions());

    static unsigned int     version();
    static Str              versionString();
    static void             logVersionInfo();

    static LogManager*      logManager();

private:
    CoreComponent();
    CEE_DISALLOW_COPY_AND_ASSIGN(CoreComponent);
};

}  

