//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/RefCountedObject.h"

namespace cee {


//==================================================================================================
//
//
//
//==================================================================================================
class CEE_CORE_EXPORT Image : public RefCountedObject
{
public:
    Image();
    Image(const Image& other);
    virtual ~Image();

    Image&                  operator=(const Image& other);

    unsigned int            width() const;
    unsigned int            height() const;
    unsigned int            byteCount() const;
    bool                    hasTransparentPixels() const;

    void                    getAsRgb(unsigned char rgbDataBuffer[], size_t bufferSizeInBytes) const;
    void                    setFromRgb(const unsigned char rgbData[], unsigned int width, unsigned int height);

    void                    getAsRgba(unsigned char rgbaDataBuffer[], size_t bufferSizeInBytes) const;
    void                    setFromRgba(const unsigned char rgbaData[], unsigned int width, unsigned int height);

    void                    clear();

    unsigned int            version() const;
    const unsigned char*    rawPointer() const;

private:
    CEE_PRIVATE_IMPL(Image);
};

}
