//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"

#include <map>

namespace cee {

class Image;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT ImageResources : public RefCountedObject
{
public:
    ImageResources();
    virtual ~ImageResources();

    Image*                      imageResource(const Str& resourceName);
    void                        addImageResource(const Str& resourceName, Image* image);

    std::map<Str, const Image*> allImageResources() const;

private:
    CEE_PRIVATE_IMPL(ImageResources);
    CEE_DISALLOW_COPY_AND_ASSIGN(ImageResources);
};

}  // namespace cee
