//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"

namespace cee {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT InitializationOptions
{
public:
    /// Enumerates action to be taken when an assert fails
    enum FailedAssertAction
    {
        NO_ACTION,                  ///< No action
        THROW_EXCEPTION,            ///< Throws an exception
        WRITE_CONSOLE_ABORT,        ///< Write asserts to console and then abort (default mode for Linux)
        SHOW_INTERACTIVE_DIALOG     ///< Show assertion message in dialog and ask for user action (Windows only, default mode on Windows)
    };

public:
    InitializationOptions();
    InitializationOptions(const InitializationOptions& other);
    ~InitializationOptions();

    InitializationOptions&  operator=(const InitializationOptions& other);

    FailedAssertAction      failedAssertAction() const;
    void                    setFailedAssertAction(FailedAssertAction failedAction);

private:
    CEE_PRIVATE_IMPL(InitializationOptions);
};


}

