//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"

namespace cee {

class InitializationOptions;


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT Instance : public RefCountedObject
{
public:
    virtual ~Instance();

    unsigned int                    version() const;
    Str                             versionString() const;

    unsigned int                    licenseKeyA() const;
    unsigned int                    licenseKeyB() const;

    const InitializationOptions&    initializationOptions() const;

private:
    Instance();

private:
    CEE_BASE_F(CoreComponent);
    CEE_PRIVATE_IMPL(Instance);
    CEE_DISALLOW_COPY_AND_ASSIGN(Instance);
};

}  
