//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/LogDestination.h"
#include "CeeCore/Str.h"

namespace cee {

class LogEvent;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT LogDestinationFile : public LogDestination
{
public:
    LogDestinationFile(const Str& fileName);
    virtual ~LogDestinationFile();

	virtual Str targetName() const;
    virtual void log(const LogEvent& logEvent);

private:
    CEE_PRIVATE_IMPL(LogDestinationFile);
    CEE_DISALLOW_COPY_AND_ASSIGN(LogDestinationFile);
};

} // namespace cee
