//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/Str.h"
#include "CeeCore/CodeLocation.h"

namespace cvf {
    class LogEvent;
}

namespace cee {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT LogEvent
{
public:
    ~LogEvent();

    Str             source() const;
    int             level() const;
    Str             message() const;
    CodeLocation    location() const;

private:
    LogEvent(const cvf::LogEvent& cvfLogEvent);

private:
    CEE_BASE_F(LogDestinationAdapter);
    CEE_BASE_F(LogDestinationConsole);
    CEE_BASE_F(LogDestinationFile);
    CEE_PRIVATE_IMPL(LogEvent);
    CEE_DISALLOW_COPY_AND_ASSIGN(LogEvent);
};


} // namespace cee
