//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Variant.h"
#include "CeeCore/Str.h"

namespace cee {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT PropertySet : public RefCountedObject
{
public:
    PropertySet(const Str& classType);
    PropertySet(const PropertySet& other);
    virtual ~PropertySet();

    PropertySet&                operator=(const PropertySet& rhs);
    bool                        operator==(const PropertySet& rhs) const;
    bool                        operator!=(const PropertySet& rhs) const;

    Str                         classType() const;

    Variant                     value(const Str& key) const;
    void                        setValue(const Str& key, Variant data);

    std::vector<Str>            allKeys() const;
    std::vector<Variant>        allValues() const;

private:
    CEE_PRIVATE_IMPL(PropertySet);
};


}  // namespace cee
