//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"

namespace cee {

class PropertySet;


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_CORE_EXPORT PropertySetCollection : public RefCountedObject
{
public:
    PropertySetCollection();
    PropertySetCollection(const PropertySetCollection& other);
    virtual ~PropertySetCollection();

    PropertySetCollection&  operator=(const PropertySetCollection& rhs);

    size_t                  count() const;
    PropertySet*            propertySet(size_t index);
    const PropertySet*      propertySet(size_t index) const;
    void                    addPropertySet(PropertySet* propertySet);

    size_t                  countOfType(const Str& classType) const;
    PropertySet*            propertySetOfType(const Str& classType, size_t index);
    const PropertySet*      propertySetOfType(const Str& classType, size_t index) const;

private:
    CEE_PRIVATE_IMPL(PropertySetCollection);
};

}  // namespace cee
