//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Core
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Vec3d.h"

namespace cvf { class Ray; }

namespace cee {


//==================================================================================================
//
//
//
//==================================================================================================
class CEE_CORE_EXPORT Ray 
{
public:
    Ray();
    Ray(const Ray& other);
    ~Ray();

    Ray&        operator=(const Ray& other);

    Vec3d       origin() const;
    void        setOrigin(const Vec3d& orig);

    Vec3d       direction() const;
    void        setDirection(const Vec3d& dir);

    double      pointAndLineSizeInPixels() const;
    void        setPointAndLineSizeInPixels(double sizeInPixels);

public:
    cvf::Ray*   internal_cvfRay();

private:
    CEE_PRIVATE_IMPL(Ray);
};

} // namespace cee
