//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeExport/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"

#include <vector>

namespace cee {

namespace ug {
class UnstructGridModel;
}

namespace exp {

//==================================================================================================
//
// Export selected view to cgeo
//
//==================================================================================================
class CEE_EXP_EXPORT ExportCgeo
{
public:
    ExportCgeo(ug::UnstructGridModel* model, size_t frameIndex);
    ~ExportCgeo();
    
    bool save(const Str& fileName);

private:
    CEE_PRIVATE_IMPL(ExportCgeo);
    CEE_DISALLOW_COPY_AND_ASSIGN(ExportCgeo);
};

}  // namespace ug
}  // namespace cee
