//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeExport/Base.h"

#include "CeeCore/Str.h"

namespace cee {

class Instance;

namespace exp {


//==================================================================================================
//
// Static class for UnstructGrid component
//
//==================================================================================================
class CEE_EXP_EXPORT ExportComponent
{
public:
    static bool             isInitialized();
    static bool             initialize(Instance* instance);

    static bool             isEvaluationVersion();
    static int              licenseNumber();

    static unsigned int     version();
    static Str              versionString();

private:
    CEE_DISALLOW_COPY_AND_ASSIGN(ExportComponent);
};


}  // namespace ug
}  // namespace cee
