//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Export
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeExport/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"

#include "CeeVisualization/Camera.h"

#include <vector>

namespace cee {

namespace ug {
class UnstructGridModel;
}

namespace exp {

//==================================================================================================
//
// Export selected view to the Constant Remote Model Database
//
//==================================================================================================
class CEE_EXP_EXPORT ExportConstantRemoteModel
{
public:
    ExportConstantRemoteModel();
    ~ExportConstantRemoteModel();
    
    static int dataFormatVersion();
    
    void setModel(ug::UnstructGridModel* model);
    void setDefaultCamera(const vis::Camera& camera);
    void setDefaultParticleTraceStepCount(size_t stepCount);
    
    bool save(const Str& outputFolder);
    bool saveBinBundle(const Str& fileName);
    bool saveJsBundle(const Str& fileName);

private:
    CEE_PRIVATE_IMPL(ExportConstantRemoteModel);
    CEE_DISALLOW_COPY_AND_ASSIGN(ExportConstantRemoteModel);
};

}  // namespace ug
}  // namespace cee
