//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeExport/Base.h"
#include "CeeCore/Str.h"
#include "CeeUnstructGrid/DataStateSpec.h"


namespace cee {
	
class Str;
class Image;

namespace ug {
	class DataSource;
}

namespace exp {

//==================================================================================================
//
// Export entire data source to VTFx
//
//==================================================================================================
class CEE_EXP_EXPORT ExportDataSourceVTFx
{
public:
	ExportDataSourceVTFx(cee::ug::DataSource* dataSource);
	virtual ~ExportDataSourceVTFx();

	void setVendorNameAndApplication(const Str& vendorName, const Str& vendorApplication);
	void setCompressionLevel(unsigned int compressionLevel);
	void setPassword(const Str& password);
	void setCreateSignature(bool on);
    void setWriteAsciiDataFiles(bool on);
    void setExportSurfaceOnly(bool on);
	void setRelativeDisplacements(bool on);
	void setExportDerivedResultAsSelfContained(bool on);

    bool write(std::vector<int> stateIds, const cee::ug::DataStateSpec& spec, const Str& fileName);
	bool write(const Str& fileName);

private:
    CEE_PRIVATE_IMPL(ExportDataSourceVTFx);
    CEE_DISALLOW_COPY_AND_ASSIGN(ExportDataSourceVTFx);
};

}  // namespace exp
}  // namespace cee
