//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2021, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeExport/Base.h"
#include "CeeCore/Str.h"


namespace cee {

namespace ug {
class UnstructGridModel;
}

namespace exp {

//==================================================================================================
//
// Export selected view to Wavefront .obj, .mtl and texture (.png) files
// Note: Experimental
//
//==================================================================================================
class CEE_EXP_EXPORT ExportWavefrontObj
{
public:
    ExportWavefrontObj(ug::UnstructGridModel* model, size_t frameIndex);
    ~ExportWavefrontObj();
    
    bool save(const Str& objFilename);

private:
    CEE_PRIVATE_IMPL(ExportWavefrontObj);
    CEE_DISALLOW_COPY_AND_ASSIGN(ExportWavefrontObj);
};

}  // namespace ug
}  // namespace cee
