//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeExport/Base.h"
#include "CeeExport/ExportVTFx.h"

namespace cee {

class PropertySetCollection;
class ImageResources;

namespace vis {
class View;
}

namespace ug {
class UnstructGridModel;
}

namespace plt {
class OverlayPlot;
}

namespace exp {


//==================================================================================================
//
// PropertyBuilderVTFx
//
//==================================================================================================
class CEE_EXP_EXPORT PropertyBuilderVTFx
{
public:
    PropertyBuilderVTFx(PropertySetCollection* propSetCollection, ImageResources* resources);
    ~PropertyBuilderVTFx();

    void    addFromModel(const ug::UnstructGridModel& model);
    void    addFromView(const vis::View& view);

    void    addDefaultFramesPerSecond(double defaultFPS);
    void    addNumberOfParticleTraceAnimationSteps(int numAnimationSteps);
    void    addStartAnimation(bool startAnimation);

    void    addAnimatedCuttingPlane(int index, int numFrames, double distance);
    void    addAnimationFirstFrameDelay(int milliSeconds);
    void    addAnimationLastFrameDelay(int milliSeconds);
    void    addViewTitle(const Str& title);

private:
    CEE_PRIVATE_IMPL(PropertyBuilderVTFx);
    CEE_DISALLOW_COPY_AND_ASSIGN(PropertyBuilderVTFx);
};

}  // namespace ug
}  // namespace cee
