//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeGeometry/Effect.h"
#include "CeeCore/Color3f.h"

namespace cee {
namespace geo {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT EffectFrontAndBackColor : public Effect
{
public:
    EffectFrontAndBackColor();
    EffectFrontAndBackColor(const Color3f& frontColor, const Color3f& backColor);
    virtual ~EffectFrontAndBackColor();

    virtual Type            type() const;
    virtual PtrRef<Effect>  clone();

    const Color3f&          frontColor() const;
    const Color3f&          backColor() const;
    void                    setColor(const Color3f& frontColor, const Color3f& backColor);

    float                   ambientIntensity() const;
    void                    setAmbientIntensity(float intensity);
                            
    float                   specularIntensity() const;
    void                    setSpecularIntensity(float intensity);

private:
    CEE_PRIVATE_IMPL(EffectFrontAndBackColor);
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_F(PartSettings);
    CEE_PRIVATE_F(PartClassification);
    CEE_DISALLOW_COPY_AND_ASSIGN(EffectFrontAndBackColor);
};

} // namespace geo
} // namespace cee
