//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeGeometry/Effect.h"

namespace cee {
namespace geo {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT EffectFrontAndBackOpacity : public Effect
{
public:
    EffectFrontAndBackOpacity();
    EffectFrontAndBackOpacity(float frontOpacity, float backOpacity);
    virtual ~EffectFrontAndBackOpacity();

    virtual Type            type() const;
    virtual PtrRef<Effect>  clone();

    float                   frontOpacity() const;
    float                   backOpacity() const;
    void                    setOpacity(float frontOpacity, float backOpacity);

private:
    CEE_PRIVATE_IMPL(EffectFrontAndBackOpacity);
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_F(PartSettings);
    CEE_PRIVATE_F(PartClassification);
    CEE_DISALLOW_COPY_AND_ASSIGN(EffectFrontAndBackOpacity);
};

} // namespace geo
} // namespace cee
