//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeGeometry/Effect.h"

namespace cee {
namespace geo {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT EffectHalo : public Effect
{
public:
    EffectHalo();
    virtual ~EffectHalo();

    virtual Type            type() const;
    virtual PtrRef<Effect>  clone();

private:
    CEE_PRIVATE_IMPL(EffectHalo);
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_F(PartSettings);
    CEE_DISALLOW_COPY_AND_ASSIGN(EffectHalo);
};

} // namespace geo
} // namespace cee
