//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeGeometry/Effect.h"

namespace cee {
namespace geo {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT EffectLighting : public Effect
{
public:
    EffectLighting();
    EffectLighting(bool enableLight);
    virtual ~EffectLighting();

    virtual Type            type() const;
    virtual PtrRef<Effect>  clone();
    
    bool                    lighting() const;
    void                    setLighting(bool enable);

private:
    CEE_PRIVATE_IMPL(EffectLighting);
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_F(PartSettings);
    CEE_PRIVATE_F(PartClassification);
    CEE_DISALLOW_COPY_AND_ASSIGN(EffectLighting);
};

} // namespace geo
} // namespace cee

