//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeGeometry/Effect.h"
#include "CeeCore/Color3f.h"

namespace cee {
namespace geo {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT EffectLineWidth : public Effect
{
public:
    EffectLineWidth();
    EffectLineWidth(unsigned int width);
    virtual ~EffectLineWidth();

    virtual Type            type() const;
    virtual PtrRef<Effect>  clone();
    
    unsigned int            width() const;
    void                    setWidth(unsigned int width);

private:
    CEE_PRIVATE_IMPL(EffectLineWidth);
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_F(PartSettings);
    CEE_PRIVATE_F(PartClassification);
    CEE_DISALLOW_COPY_AND_ASSIGN(EffectLineWidth);
};

} // namespace geo
} // namespace cee

