//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeGeometry/Effect.h"

namespace cee {
namespace geo {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT EffectOpacity : public Effect
{
public:
    EffectOpacity();
    EffectOpacity(float opacity);
    virtual ~EffectOpacity();

    virtual Type            type() const;
    virtual PtrRef<Effect>  clone();

    float                   opacity() const;
    void                    setOpacity(float opacity);

private:
    CEE_PRIVATE_IMPL(EffectOpacity);
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_F(PartSettings);
    CEE_PRIVATE_F(PartClassification);
    CEE_DISALLOW_COPY_AND_ASSIGN(EffectOpacity);
};

} // namespace geo
} // namespace cee
