//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeCore/Base.h"
#include "CeeCore/Vec3d.h"

namespace cee {
namespace geo {

class Part;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT HitItem
{
public:
    HitItem();
    ~HitItem();

    const Part*     part() const;
    Part*           part();
    void            setPart(Part* part);

    const Vec3d&    intersectionPoint() const;
    void            setIntersectionPoint(const Vec3d& intersectionPoint);

    size_t          itemIndex() const;
    void            setItemIndex(size_t index);

private:
    CEE_PRIVATE_IMPL(HitItem);
    CEE_DISALLOW_COPY_AND_ASSIGN(HitItem);
};

} // namespace geo
} // namespace cee

