//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeCore/Base.h"

#include <vector>

namespace cee {
namespace geo {

class Part;

//==================================================================================================
//
// 
//
//==================================================================================================
struct CEE_GEO_EXPORT PartHitItems
{
public:
    PartHitItems();
    PartHitItems(const PartHitItems& other);
    ~PartHitItems();
    
    PartHitItems&   operator=(const PartHitItems& other);

    const Part*     part() const;
    Part*           part();

    const std::vector<size_t>& itemIndexArr() const;

private:
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_IMPL(PartHitItems);
};

} // namespace geo
} // namespace cee
