//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Geometry
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeGeometry/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Vec2f.h"

#include <vector>

namespace cee {
namespace geo {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_GEO_EXPORT TextureCoordinates : public RefCountedObject
{
public:
    TextureCoordinates();
    TextureCoordinates(const std::vector<Vec2f>& coordinates);
    virtual ~TextureCoordinates();

    std::vector<Vec2f> coordinates() const;
    void               setCoordinates(const std::vector<Vec2f>& coordinates);

private:
    CEE_PRIVATE_IMPL(TextureCoordinates);
    CEE_PRIVATE_F(GeometryModel);
    CEE_PRIVATE_F(Part);
    CEE_DISALLOW_COPY_AND_ASSIGN(TextureCoordinates);
};

} // namespace geo
} // namespace cee
