//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: ImportCae
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2017, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeImportCae/Base.h"
#include "CeeUnstructGrid/DataSourceMemory.h"

namespace cee {
namespace ug {

class DataGeometry;
class DataState;
class UnstructGridModel;

}
}

namespace cee {
namespace imp {
namespace cae {

class DataSourceCae;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_IMP_CAE_EXPORT DataSourcePhaseResponse : public cee::ug::DataSourceMemory
{
public:
	DataSourcePhaseResponse(int id, const DataSourceCae* sourceDataSource, int frequencyStateId, size_t numSteps);
	virtual ~DataSourcePhaseResponse();
	bool build();


private:
    CEE_PRIVATE_IMPL(DataSourcePhaseResponse);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataSourcePhaseResponse);

};

}  // namespace cae
}  // namespace imp
}  // namespace cee
