//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: ImportCae
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2017, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeImportCae/Base.h"
#include "CeeUnstructGrid/DataSourceReader.h"

namespace cee {
namespace ug {

class DataGeometry;
class DataState;
class Error;
class UnstructGridModel;

}
}

namespace cee {
namespace imp {
namespace cae {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_IMP_CAE_EXPORT StateLinearCombination : public cee::RefCountedObject
{
public:
    StateLinearCombination(cee::ug::UnstructGridModel* sourceModel, const std::vector<int>& sourceStateIds, const std::vector<double>& combinedStateReferenceValues);
	virtual ~StateLinearCombination();

    void setSourceStateWeights(int sourceStateId, const std::vector<double>& weights);

    bool build();
    void setBuildFolderLocation(const cee::Str& location);
    bool deleteBuildFolder();

    void setUseParallelComputation(bool use);

    bool write(const cee::Str& vtfxFile);


private:
    CEE_PRIVATE_IMPL(StateLinearCombination);
    CEE_DISALLOW_COPY_AND_ASSIGN(StateLinearCombination);

};

}  // namespace cae
}  // namespace imp
}  // namespace cee
