//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Plot2d
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2016, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeePlot2d/Base.h"

#include "CeeCore/Color3f.h"
#include "CeeCore/Str.h"

#include "CeeVisualization/Font.h"

namespace cee {
namespace plt {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_PLT_EXPORT AxisSettings
{
public:
    virtual ~AxisSettings();

    Color3f     axisColor() const;
    void        setAxisColor(const Color3f& color);
   
    Str         xAxisTitle() const;
    void        setXAxisTitle(const Str& title);

    Str         yAxisTitle() const;
    void        setYAxisTitle(const Str& title);

    bool        drawGridLines() const;
    void        setDrawGridLines(bool drawGridLines);

    bool        showRangeInTitle() const;
    void        setShowRangeInTitle(bool show);

    Color3f     gridLinesColor() const;
    void        setGridLinesColor(const Color3f& color);

    bool        useAutoRange() const;
    void        setUseAutoRange(bool autoRange);

    double      xAxisRangeMinimum() const;
    double      xAxisRangeMaximum() const;
    void        setXAxisRange(double min, double max);

    double      yAxisRangeMinimum() const;
    double      yAxisRangeMaximum() const;
    void        setYAxisRange(double min, double max);

    void        forceRangeUpdate();

private:
    AxisSettings();

private:
    CEE_PRIVATE_F(OverlayPlot);
    CEE_PRIVATE_IMPL(AxisSettings);
    CEE_DISALLOW_COPY_AND_ASSIGN(AxisSettings);
};

}  // namespace plt
}  // namespace cee
