//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Plot2d
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2016, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeePlot2d/Base.h"

#include "CeeCore/Color3f.h"
#include "CeeCore/Str.h"
#include "CeeCore/Vec2d.h"

#include "CeeVisualization/Font.h"

namespace cee {
    
namespace plt {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_PLT_EXPORT Curve
{
public:
    Curve(const Curve& other);
    ~Curve();

    Curve& operator=(const Curve& other);

    size_t              valueCount() const;
    void                setValues(const std::vector<double>& xValues, const std::vector<double>& yValues);
    std::vector<double> xValues() const;
    std::vector<double> yValues() const;

    Vec2d               value(size_t valueIndex) const;
    Color3f             color() const;
    void                setColor(const Color3f& color);

    Str                 title() const;
    void                setTitle(const Str& title);

    double              xValuesMinimum() const;
    double              xValuesMaximum() const;
    double              yValuesMinimum() const;
    double              yValuesMaximum() const;

private:
    Curve();
    Curve(const Str& title, const std::vector<double>& xValues, const std::vector<double>& yValues);

    void                updateRange();

private:
    CEE_BASE_F(Plot);
    CEE_PRIVATE_IMPL(Curve);
};

}  // namespace plt
}  // namespace cee
