//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Plot2d
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2016, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeePlot2d/Base.h"

#include "CeeCore/Color3f.h"
#include "CeeCore/Str.h"

#include "CeeVisualization/Font.h"

namespace cee {
namespace plt {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_PLT_EXPORT MarkerLine
{
public:
    virtual ~MarkerLine();

    double  value() const;
    void    setValue(double position);

    bool    drawLine() const;
    void    setDrawLine(bool drawMarkerLine);
    
    Color3f color() const;
    void    setColor(const Color3f& color);

private:
    MarkerLine();
    CEE_PRIVATE_F(OverlayPlot);
    CEE_PRIVATE_IMPL(MarkerLine);
    CEE_DISALLOW_COPY_AND_ASSIGN(MarkerLine);
};

}  // namespace plt
}  // namespace cee
