//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Report
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeReport/Base.h"

#include "CeeReport/Repository.h"

#include <string>
#include <vector>

namespace cee {
namespace rep {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_REP_EXPORT ReportCreatorPowerPoint
{
public:
    ReportCreatorPowerPoint(Repository* repository, const Str& templateFile);
    virtual ~ReportCreatorPowerPoint();

    bool        generate(const Str& reportFile) const; 
    bool	    validate(Str* summary) const;
    static bool summarize(const Str& templateFile, Str* summary);

    void        setReferenceRepository(Repository* repository);
    void        setGenericSnapshotIndices(const std::vector<unsigned int>& indices);
    void        setEmbedVTFx(bool embed);
    void        setUse3dPlugin(bool use); 

private:
    CEE_PRIVATE_IMPL(ReportCreatorPowerPoint);
    CEE_DISALLOW_COPY_AND_ASSIGN(ReportCreatorPowerPoint);

};

} // namespace rep
} // namespace cee

