//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Report
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeReport/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Image.h"
#include "CeeCore/Str.h"

#include <string>

namespace cee {
namespace rep {

class Snapshot;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_REP_EXPORT Repository : public RefCountedObject
{
public:
    Repository();
    virtual ~Repository();

    bool                loadRepository(const Str& filename);
    bool                saveRepository(const Str& filename);

    size_t              snapshotCount() const;
    Snapshot*           snapshot(size_t index);
    const Snapshot*     snapshot(size_t index) const;
    void                addSnapshot(Snapshot* snapshot);
    bool                removeSnapshot(size_t index);
    void                removeAllSnapshots();

private:
    CEE_PRIVATE_IMPL(Repository);
    CEE_DISALLOW_COPY_AND_ASSIGN(Repository);
};

} // namespace rep
} // namespace cee
