//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Report
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeReport/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"

#include <string>

namespace cee {
namespace rep {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_REP_EXPORT Table : public RefCountedObject
{
public:
    Table(size_t numRows, size_t numCols);
    Table(const Table& other);
    virtual ~Table();

    Table&  operator=(const Table& other);

    Str     value(size_t row, size_t col) const;
    bool    setValue(size_t row, size_t col, const Str& val);
    size_t  rowCount() const;
    size_t  columnCount() const;

    Str     chartYAxisTitle() const;
    void    setChartYAxisTitle(const Str& yAxisTitle);
    Str     chartXAxisTitle() const;
    void    setChartXAxisTitle(const Str& xAxisTitle);

private:
    CEE_PRIVATE_IMPL(Table);
};

} // namespace rep
} // namespace cee
