//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Color3f.h"
#include "CeeCore/Str.h"


namespace cee {
namespace ug {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT ContourLines : public RefCountedObject
{
public:
    /// Color scheme used for coloring the contour lines
    enum ColorMode
    {
        SINGLE,             ///< Single color
        COLOR_BY_SCALAR     ///< Color by associated scalar result
    };

public:
    virtual ~ContourLines();

    size_t       levelCount() const;
    void         setLevelCount(size_t count);

    unsigned int lineWidth() const;
    void         setLineWidth(unsigned int width);

    ColorMode    colorMode() const;
    void         setColorMode(ColorMode mode);

    cee::Color3f singleColor() const;
    void         setSingleColor(const Color3f& color);

private:
    ContourLines();
    CEE_PRIVATE_F(ScalarSettings);
    CEE_PRIVATE_IMPL(ContourLines);
    CEE_DISALLOW_COPY_AND_ASSIGN(ContourLines);
};

}  // namespace ug
}  // namespace cee

