//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/RefCountedObject.h"

#include <vector>

namespace cee {
namespace ug {
    
//==================================================================================================
//
//  
//  
//==================================================================================================
class CEE_UG_EXPORT CustomResultFunction : public RefCountedObject
{
public:
    CustomResultFunction();
    virtual ~CustomResultFunction();

    void setInputDimensions(const std::vector<size_t>& inputDimensions);
    void setOutputDimension(size_t outputDimension);

    size_t inputCount() const;
    size_t inputDimension(size_t argumentIndex) const;
    size_t outputDimension() const;

    virtual bool computeItem(const std::vector<const double*>& inputValues, double* outputValues);

private:
    CEE_PRIVATE_IMPL(CustomResultFunction);
};



}  // namespace ug
}  // namespace cee
