//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Vec3d.h"

#include <vector>

namespace cee {
namespace ug {

class UnstructGridModel;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT CuttingPlaneAnimation
{
public:
    CuttingPlaneAnimation(UnstructGridModel* model, size_t cuttingPlaneIndex);
    ~CuttingPlaneAnimation();

    void    setFrameCount(size_t frameCount);
    void    setPerFrameDistance(double distance);

    void    generateAnimation();
    
private:
    CEE_PRIVATE_IMPL(CuttingPlaneAnimation);
    CEE_DISALLOW_COPY_AND_ASSIGN(CuttingPlaneAnimation);
};

}  // namespace ug
}  // namespace cee
