//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Vec3d.h"

#include <vector>

namespace cee {
namespace ug {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT CuttingPlaneData
{
public:
    CuttingPlaneData();
    ~CuttingPlaneData();

    void allTriangles(std::vector<unsigned int>* triangles) const;
    void allVertices(std::vector<Vec3d>* vertices) const;
    void allScalarResults(std::vector<double>* scalarResult) const;
    void allVectorResults(std::vector<Vec3d>* vectorResult) const;
    
    void allTrianglesSourceElementIndices(std::vector<size_t>* elementIndices) const;
    void allTrianglesSourcePartIndices(std::vector<size_t>* partIndices) const;
    
    void allLines(std::vector<unsigned int>* lines) const;
    void allLinesSourceElementIndices(std::vector<size_t>* elementIndices) const;
    void allLinesSourcePartIndices(std::vector<size_t>* partIndices) const;

    void allOriginalTriangles(std::vector<unsigned int>* triangles, std::vector<Vec3d>* vertices);

private:
    CEE_BASE_F(CuttingPlane);
    CEE_PRIVATE_IMPL(CuttingPlaneData);
};

}  // namespace ug
}  // namespace cee
