//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2021, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once


#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataElementSetItem.h"
#include "CeeUnstructGrid/DataElementSet.h"

#include "CeeCore/PtrRef.h"


namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataElementSetBuilder
{
public:
    DataElementSetBuilder(int setId);
    virtual ~DataElementSetBuilder();

    void                    addItem(const DataElementSetItem& item);
    void                    addItems(int geometryId, int partId, const std::vector<size_t>& elementIndices);
    void                    addUniqueItem(const DataElementSetItem& item);
    void                    addUniqueItems(int geometryId, int partId, const std::vector<size_t>& elementIndices);

    PtrRef<DataElementSet>  createSet();

private:
    CEE_PRIVATE_IMPL(DataElementSetBuilder);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataElementSetBuilder);
};


}  // namespace ug
}  // namespace cee
