//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

namespace cee {
namespace ug {

//==================================================================================================
//
//
//
//==================================================================================================
class CEE_UG_EXPORT DataElementSetItem
{
public:
    DataElementSetItem();
    DataElementSetItem(int geometryId, int partId, size_t elementIndex);
    DataElementSetItem(const DataElementSetItem& other);
    ~DataElementSetItem();
    
    DataElementSetItem& operator=(const DataElementSetItem& other);
    bool                operator==(const DataElementSetItem& rhs) const;
    bool                operator!=(const DataElementSetItem& rhs) const;

    int     geometryId() const;
    void    setGeometryId(int geometryId);
    
    int     partId() const;
    void    setPartId(int partId);
    
    size_t	elementIndex() const;
    void    setElementIndex(size_t elementIndex);

private:
    CEE_PRIVATE_IMPL(DataElementSetItem);
};

}  // namespace ug
}  // namespace cee
