//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataPart.h"

namespace cee {
namespace ug {



//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataGeometry : public RefCountedObject
{
public:
    DataGeometry();
    virtual ~DataGeometry();
    
    int                 id() const;

    size_t              partCount() const;
    const DataPart*     part(size_t partIndex) const;
    DataPart*           part(size_t partIndex);
    size_t              partIndex(int partId) const;
    void                addPart(DataPart* part);
    void                removeAllParts();
    void                removeEmptyParts();

private:
    CEE_PRIVATE_F(DataState);
    CEE_PRIVATE_IMPL(DataGeometry);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataGeometry);
};


}  // namespace ug
}  // namespace cee
