//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2016, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

namespace cee {
namespace ug {

//==================================================================================================
//
//
//
//==================================================================================================
class CEE_UG_EXPORT DataNodeSetItem
{
public:
    DataNodeSetItem();
    DataNodeSetItem(int geometryId, int partId, size_t nodeIndex);
    DataNodeSetItem(const DataNodeSetItem& other);
    
    const DataNodeSetItem&  operator=(const DataNodeSetItem& other);
    bool                    operator==(const DataNodeSetItem& rhs) const;
    bool                    operator!=(const DataNodeSetItem& rhs) const;
    bool                    operator<(const DataNodeSetItem& other) const;
    bool                    operator>(const DataNodeSetItem& other) const;

    int     geometryId() const;
    void    setGeometryId(int geometryId);
    
    int     partId() const;
    void    setPartId(int partId);
    
    size_t	nodeIndex() const;
    void    setNodeIndex(size_t nodeIndex);

private:
    int     m_geometryId;
    int     m_partId;
    size_t  m_nodeIndex;
};

}  // namespace ug
}  // namespace cee
