//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataNodes.h"
#include "CeeUnstructGrid/DataElements.h"

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataPart : public RefCountedObject
{
public:
    DataPart(int id);
    virtual ~DataPart();

    int                 partId() const;

    const DataNodes*    nodes() const;
    DataNodes*          nodes();
    void                setNodes(DataNodes* nodes);

    const DataElements* elements() const;
    DataElements*       elements();
    void                setElements(DataElements* elements);

private:
    CEE_PRIVATE_F(DataGeometry);
    CEE_PRIVATE_F(DataPartScalar);
    CEE_PRIVATE_F(DataPartVector);
    CEE_PRIVATE_IMPL(DataPart);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataPart);
};


}  // namespace ug
}  // namespace cee
