//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Vec3d.h"

#include <vector>

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataPartDisplacement : public RefCountedObject
{
public:
    DataPartDisplacement();
    virtual ~DataPartDisplacement();

    size_t          count() const;

    Vec3d           value(size_t index) const;
    const double*   rawValuePointer() const;
    double*         rawValuePointer();

    void            resize(size_t count);
    void            setValue(size_t index, const Vec3d& value);

    void            setValues(const std::vector<Vec3d>& values);
    void            setValues(const double values[], size_t vectorCount);
    void            setValuesFloat(const float values[], size_t vectorCount);

private:
    CEE_PRIVATE_F(DataResultDisplacement);
    CEE_PRIVATE_F(ElementsQuery);
    CEE_PRIVATE_IMPL(DataPartDisplacement);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataPartDisplacement);
};


}  // namespace ug
}  // namespace cee
