//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"

#include <vector>

namespace cee {
namespace ug {

class DataPart;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataPartScalar : public RefCountedObject
{
public:
    DataPartScalar();
    virtual ~DataPartScalar();

    size_t          count() const;

    double          value(size_t index) const;
    const double*   rawValuePointer() const;
    double*         rawValuePointer();

    void            resize(size_t count);
    void            setValue(size_t index, double value);

    void            setValues(const std::vector<double>& values);
    void            setValues(const double values[], size_t count);
    void            setValuesFloat(const float values[], size_t count);

    bool            valueRange(double* min, double* max) const;

    bool            hasNodeAverageValues() const;
    double          nodeAverageValue(size_t nodeIndex) const;

    void            updateMinMax();

private:
    CEE_PRIVATE_F(DataResultScalar);
    CEE_PRIVATE_F(ElementsQuery);
    CEE_PRIVATE_IMPL(DataPartScalar);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataPartScalar);
};


}  // namespace ug
}  // namespace cee
