//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/SymmetricTensor.h"

#include <vector>

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataPartSymmetricTensor : public RefCountedObject
{
public:
    DataPartSymmetricTensor();
    virtual ~DataPartSymmetricTensor();

    size_t          count() const;
    const SymmetricTensor& value(size_t index) const;
    SymmetricTensor& value(size_t index);

    const double*   rawValuePointer() const;
    double*         rawValuePointer();

    void            resize(size_t count);
    void            setValue(size_t index, const SymmetricTensor& value);
    void            setValueUndefined(size_t index);

    void            setValues(const std::vector<SymmetricTensor>& values);
    void            setValues(const double values[], size_t symmetricTensorCount);

private:
    CEE_PRIVATE_F(DataResultSymmetricTensor);
    CEE_PRIVATE_IMPL(DataPartSymmetricTensor);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataPartSymmetricTensor);

};

}  // namespace ug
}  // namespace cee
