//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"

#include <vector>

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataPartVisibility : public RefCountedObject
{
public:
    DataPartVisibility();
    virtual ~DataPartVisibility();

    size_t          count() const;
    bool            value(size_t index) const;
    const bool*     rawValuePointer() const;
    bool*           rawValuePointer();

    void            resize(size_t count);
    void            setValue(size_t index, bool visible);

    void            setValues(const std::vector<bool>& values);
    void            setValues(const bool values[], size_t elementCount);

private:
    CEE_PRIVATE_F(DataResultVisibility);
    CEE_PRIVATE_IMPL(DataPartVisibility);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataPartVisibility);
};


}  // namespace ug
}  // namespace cee
