//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataPartDisplacement.h"

namespace cee {
namespace ug {

class DataGeometry;
class DataResultScalar;
class DataResultVector;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataResultDisplacement : public RefCountedObject
{
public:
    DataResultDisplacement(int resultId);
    virtual ~DataResultDisplacement();

    int                         resultId() const;

    size_t                      partCount() const;
    const DataPartDisplacement* part(size_t partIndex) const;
    DataPartDisplacement*       part(size_t partIndex);
    void                        addPart(DataPartDisplacement* part);
    void                        removeAllParts();

    bool                        deriveScalar(DeriveOperation deriveOperation, DataResultScalar* derivedScalar, const DataGeometry* geometry) const;
    bool                        deriveVector(DeriveOperation deriveOperation, DataResultVector* derivedVector, const DataGeometry* geometry) const;

private:
    CEE_PRIVATE_F(DataResultGroup);
    CEE_PRIVATE_IMPL(DataResultDisplacement);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataResultDisplacement);
};


}  // namespace ug
}  // namespace cee
