//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataPartScalar.h"

namespace cee {
namespace ug {

class DataGeometry;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataResultScalar : public RefCountedObject
{
public:
    DataResultScalar(int resultId, ResultMapping mappingType);
    virtual ~DataResultScalar();

    int                     resultId() const;

    size_t                  partCount() const;
    const DataPartScalar*   part(size_t partIndex) const;
    DataPartScalar*         part(size_t partIndex);
    ResultMapping           resultMapping() const;
    void                    addPart(DataPartScalar* part);
    void                    removeAllParts();

    void                    computeNodeAverage(const DataGeometry* geometry);

private:
    CEE_PRIVATE_F(DataResultGroup);
    CEE_PRIVATE_IMPL(DataResultScalar);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataResultScalar);
};


}  // namespace ug
}  // namespace cee
