//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataPartSymmetricTensor.h"

namespace cee {
namespace ug {

class DataResultScalar;
class DataResultVector;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataResultSymmetricTensor : public RefCountedObject
{
public:
    DataResultSymmetricTensor(int resultId, ResultMapping mappingType);
    virtual ~DataResultSymmetricTensor();

    int                             resultId() const;

    size_t                          partCount() const;
    const DataPartSymmetricTensor*  part(size_t partIndex) const;
    DataPartSymmetricTensor*        part(size_t partIndex);
    ResultMapping                   resultMapping() const;
    void                            addPart(DataPartSymmetricTensor* part);
    void                            removeAllParts();

    bool                            deriveScalar(DeriveOperation deriveOperation, DataResultScalar* derivedScalar) const;
    bool                            deriveVector(DeriveOperation deriveOperation, DataResultVector* derivedVector) const;

private:
    CEE_PRIVATE_F(DataResultGroup);
    CEE_PRIVATE_IMPL(DataResultSymmetricTensor);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataResultSymmetricTensor);
};


}  // namespace ug
}  // namespace cee
