//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Mat4d.h"

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataResultTransformation : public RefCountedObject
{
public:
    DataResultTransformation();
    virtual ~DataResultTransformation();

    size_t                  partCount() const;
    Mat4d                   part(size_t partIndex) const;
    void                    addPart(const Mat4d& part);
    void                    removeAllParts();

private:
    CEE_PRIVATE_F(DataResultGroup);
    CEE_PRIVATE_IMPL(DataResultTransformation);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataResultTransformation);
};


}  // namespace ug
}  // namespace cee
