//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataPartVector.h"

namespace cee {
namespace ug {

class DataResultScalar;
class DataGeometry;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataResultVector : public RefCountedObject
{
public:
    DataResultVector(int resultId, ResultMapping mappingType);
    virtual ~DataResultVector();

    int                     resultId() const;

    size_t                  partCount() const;
    const DataPartVector*   part(size_t partIndex) const;
    DataPartVector*         part(size_t partIndex);
    ResultMapping           resultMapping() const;
    void                    addPart(DataPartVector* part);
    void                    removeAllParts();

    bool                    deriveScalar(DeriveOperation deriveOperation, DataResultScalar* derivedScalar) const;

    void                    computeNodeAverage(const DataGeometry* geometry);

private:
    CEE_PRIVATE_F(DataResultGroup);
    CEE_PRIVATE_IMPL(DataResultVector);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataResultVector);
};


}  // namespace ug
}  // namespace cee
