//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataPartVisibility.h"

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataResultVisibility : public RefCountedObject
{
public:
    DataResultVisibility();
    virtual ~DataResultVisibility();

    size_t                      partCount() const;
    const DataPartVisibility*   part(size_t partIndex) const;
    DataPartVisibility*         part(size_t partIndex);
    void                        addPart(DataPartVisibility* part);
    void                        removeAllParts();

private:
    CEE_PRIVATE_F(DataResultGroup);
    CEE_PRIVATE_IMPL(DataResultVisibility);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataResultVisibility);
};


}  // namespace ug
}  // namespace cee
