//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataSource.h"

namespace cee {
namespace ug {



//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataSourceMemory : public DataSource
{
public:
    DataSourceMemory(int dataSourceId, size_t geometryCountPerState);
    virtual ~DataSourceMemory();

    size_t                              geometryCountPerState() const;

    bool                                updateDerivedResult(ResultType resultType, int id);
    bool                                updateAllDerivedResults();

    void                                addState(DataState* state); 
    void                                removeAllStates();
    void                                updateDirectoryFromStates();

private:
    virtual bool                        loadCustomResultBaseDependencies(int stateId, const DataStateSpec& stateSpec);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataSourceMemory);
};

}  // namespace ug
}  // namespace cee
