//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################


#pragma once

#include "CeeCore/PtrRef.h"
#include "CeeImportCae//Base.h"
#include "CeeUnstructGrid/DataSourceInterface.h"

#include "CeeCore/Base.h"

#include <map>
#include <vector>

namespace cee {
namespace ug {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataSourceMerged : public cee::ug::DataSourceInterface
{
public:
    virtual ~DataSourceMerged();
    DataSourceMerged(int dataSourceId);
    DataSourceMerged(int dataSourceId, cee::ug::DataSourceInterface* mainDataSource);

    int             nextDataSourceId() const;

    bool            append(cee::ug::DataSourceInterface* dataSource);
    virtual bool    open(const Str& filename, cee::ug::Error* error = NULL);
    virtual void    close();

private:
    static bool     areDataSourcesCompatible(const cee::ug::DataSourceInterface* dataSource1, const cee::ug::DataSourceInterface* dataSource2);

private:
    CEE_PRIVATE_IMPL(DataSourceMerged);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataSourceMerged);


};

}  // namespace ug
}  // namespace cee
