//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/DataSourceInterface.h"
#include "CeeUnstructGrid/DataStateSpec.h"
#include "CeeUnstructGrid/DataReader.h"

class VTDatabase;

namespace cee {
namespace ug {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataSourceReader : public DataSourceInterface
{
public:
    DataSourceReader(int dataSourceId, DataReader* reader);
    virtual ~DataSourceReader();
    
    virtual bool    open(const Str& filename, Error* error = NULL);
    virtual void    close();
    virtual bool    reload(bool force, Error* error = NULL);
    
    virtual bool    loadState(int stateId, const DataStateSpec& stateSpec, Error* error);
    
    virtual bool    scalarRange(int stateId, int resultId, double* min, double* max);
    virtual bool    vectorRange(int stateId, int resultId, double* min, double* max);

private:
    CEE_PRIVATE_IMPL(DataSourceReader);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataSourceReader);
};


}  // namespace ug
}  // namespace cee
