//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/ResultInfo.h"

#include "CeeCore/RefCountedObject.h"

#include <vector>

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DataStateSpec
{
public:
    DataStateSpec();
    ~DataStateSpec();
    
    std::vector<int>        scalarResultIds() const;
    void                    setScalarResultIds(const std::vector<int>& scalarIds);

    std::vector<int>        vectorResultIds() const;
    void                    setVectorResultIds(const std::vector<int>& vectorIds);

    std::vector<int>        displacementResultIds() const;
    void                    setDisplacementResultIds(const std::vector<int>& displacementIds);

    std::vector<int>        symmetricTensorResultIds() const;
    void                    setSymmetricTensorResultIds(const std::vector<int>& symmetricTensorIds);

    void                    setResultIds(const std::vector<ResultInfo>& resultInfos);

    bool                    loadTransformationResult() const;
    void                    setLoadTransformationResult(bool load);

	std::vector<int>		setIds() const;
	void					setSetIds(const std::vector<int>& setIds);

private:
    CEE_PRIVATE_IMPL(DataStateSpec);
    CEE_DISALLOW_COPY_AND_ASSIGN(DataStateSpec);
};


}  // namespace ug
}  // namespace cee
