//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT DisplacementSettings : public RefCountedObject
{
public:
    virtual ~DisplacementSettings();

    double  scaleFactor() const;
    void    setScaleFactor(double scaleFactor);

private:
    DisplacementSettings();
    CEE_PRIVATE_F(UnstructGridModel);
    CEE_PRIVATE_IMPL(DisplacementSettings);
    CEE_DISALLOW_COPY_AND_ASSIGN(DisplacementSettings);
};

}  // namespace ug
}  // namespace cee

