//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/Pimpl.h"
#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/HitItem.h"

namespace cee {
namespace ug {

//==================================================================================================
//
/// A collection of HitItem instances 
//
//==================================================================================================
class CEE_UG_EXPORT HitItemCollection
{
public:
    HitItemCollection();
    HitItemCollection(const HitItemCollection& other);
    virtual ~HitItemCollection();

    HitItemCollection& operator=(const HitItemCollection& other);
    
    size_t      count() const;
    HitItem     item(size_t index) const;
    void        add(const HitItem& item);

    HitItemCollection firstItems(double equalItemThreshold) const;

    
private:
    CEE_PRIVATE_IMPL(HitItemCollection);

};


}  // namespace ug
}  // namespace cee
