//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Vec3d.h"

#include <vector>

namespace cee {
namespace ug {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT IsovolumeData
{
public:
    IsovolumeData();
    ~IsovolumeData();

    void allTriangles(std::vector<unsigned int>* triangles) const;
    void allVertices(std::vector<Vec3d>* vertices) const;
    void allScalarResults(std::vector<double>* scalarResult) const;
    void allVectorResults(std::vector<Vec3d>* vectorResult) const;

private:
    CEE_BASE_F(Isovolume);
    CEE_PRIVATE_IMPL(IsovolumeData);
};

}  // namespace ug
}  // namespace cee
