//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Plane.h"

namespace cee {
namespace ug {



//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT MirrorSettings
{
public:
    virtual ~MirrorSettings();

    bool            isMirrorEnabled() const;
    void            enableMirroring(bool enable);

    bool            isReflective() const;
    void            setReflective(bool reflective);

    unsigned int    numberOfMirrorPasses() const;
    void            setNumberOfMirrorPasses(unsigned int numPasses);
    unsigned int    maximumNumberOfMirrorPasses() const;

    Plane           firstPlane() const;
    Plane           secondPlane() const;
    Plane           masterPlane() const;
    void            setFirstPlane(Plane plane);
    void            setSecondPlane(Plane plane);
    void            setMasterPlane(Plane plane);

private:
    MirrorSettings();
    CEE_PRIVATE_F(UnstructGridModel);
    CEE_PRIVATE_IMPL(MirrorSettings);
    CEE_DISALLOW_COPY_AND_ASSIGN(MirrorSettings);
};

}  // namespace ug
}  // namespace cee
