//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeVisualization/OverlayItem.h"

namespace cee {
namespace ug {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT OverlayColorLegend : public vis::OverlayItem
{
public:
    virtual ~OverlayColorLegend();

    int                     resultId() const;

    virtual unsigned int    width() const;
    virtual unsigned int    height() const;
    virtual void            setSize(unsigned int width, unsigned int height);

    virtual int             priority() const;
    virtual void            setPriority(int priority);

private:
    virtual cvf::OverlayItem* internal_cvfOverlayItem();

private:
    OverlayColorLegend();
    CEE_PRIVATE_F(UnstructGridModel);
    CEE_PRIVATE_IMPL(OverlayColorLegend);
    CEE_DISALLOW_COPY_AND_ASSIGN(OverlayColorLegend);
};


}  // namespace ug
}  // namespace cee
