//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Vec3d.h"
#include "CeeUnstructGrid/HitItem.h"

#include <vector>

namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT PartHitItems
{
public:
    PartHitItems();
    PartHitItems(const PartHitItems& other);
    ~PartHitItems();

    PartHitItems& operator=(const PartHitItems& other);

    int                                 stateId() const;
    void                                setStateId(int stateId);

    size_t                              frameIndex() const;
    void                                setFrameIndex(size_t frameIndex);
    
    size_t                              geometryIndex() const;
    void                                setGeometryIndex(size_t geometryIndex);

    int                                 partId() const;
    void                                setPartId(int itemId);

    size_t                              partIndex() const;
    void                                setPartIndex(size_t partIndex);

    const std::vector<unsigned int>&    elementIndices() const;
    void                                setElementIndices(const std::vector<unsigned int>& indices);

    size_t                              elementCount() const;
    HitItem                             elementHitItem(size_t elementIndex) const;

private:
    CEE_PRIVATE_IMPL(PartHitItems);
};


}  // namespace ug
}  // namespace cee
