//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/Str.h"

namespace cee {
namespace ug {



//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT PartInfo
{
public:
    PartInfo();
    PartInfo(int partId, const Str& partName);
    PartInfo(const PartInfo& other);
    ~PartInfo();

    PartInfo&           operator=(const PartInfo& rhs);
    bool                operator==(const PartInfo& rhs) const;
    bool                operator!=(const PartInfo& rhs) const;

    int                 id() const;
    Str                 name() const;

    bool                isBoundaryCondition() const;
    void                setBoundaryCondition(bool on);

    int                 parentId() const;
    void                setParentId(int parentId);

    Str                 partDataValue(const Str& name) const;
    std::vector<Str>    partDataNames() const;
    void                setPartData(const Str& name, const Str& value);

private:
    CEE_PRIVATE_IMPL(PartInfo);
};

}  // namespace ug
}  // namespace cee
