//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeUnstructGrid/Base.h"
#include <vector>

namespace cee {
namespace ug {

class PartSettings;
class UnstructGridModel;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT PartSettingsIterator
{
public:
    PartSettingsIterator(UnstructGridModel* model);
    PartSettingsIterator(UnstructGridModel* model, size_t globalGeometryIndex);
    ~PartSettingsIterator();

    bool            hasNext() const;
    PartSettings*   next();

private:
    CEE_PRIVATE_IMPL(PartSettingsIterator);
    CEE_DISALLOW_COPY_AND_ASSIGN(PartSettingsIterator);
};

}  // namespace ug
}  // namespace cee
