//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/RefCountedObject.h"

namespace cee {
class Image;

namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT PartSettingsTexture : public RefCountedObject
{
public:
    virtual ~PartSettingsTexture();

    Image*      image() const;
    void        setImage(Image* image);

    bool        environmentMapping() const;
    void        setEnvironmentMapping(bool useEnvironmentMapping);

    float       repeatFactor() const;
    void        setRepeatFactor(float repeatFactor);

    bool        autoScaling() const;
    void        setAutoScaling(bool autoScaling);

    bool        modulate() const;
    void        setModulate(bool modulate);

    bool        filterNearest() const;
    void        setFilterNearest(bool filterNearest);

private:
    PartSettingsTexture();
    CEE_PRIVATE_F(PartSettings);
    CEE_PRIVATE_IMPL(PartSettingsTexture);
    CEE_DISALLOW_COPY_AND_ASSIGN(PartSettingsTexture);
};

}  // namespace ug
}  // namespace cee

