//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Vec3d.h"
#include "CeeCore/Color3f.h"

#include <vector>

namespace cee {
namespace ug {

//==================================================================================================
//
//
//
//==================================================================================================
class CEE_UG_EXPORT ParticleTraceData
{
public:
    ParticleTraceData();
    ParticleTraceData(const ParticleTraceData& other);
    ~ParticleTraceData();

    ParticleTraceData&  operator=(const ParticleTraceData& other);

    std::vector<Vec3d>  positions() const;
    void                setPositions(const std::vector<Vec3d>& positions);

    std::vector<double> timeStamps() const;
    void                setTimeStamps(const std::vector<double>& timeStamps);

    std::vector<double> scalarValues() const;
    void                setScalarValues(const std::vector<double>& scalarValues);

private:
    CEE_PRIVATE_IMPL(ParticleTraceData);
};

}  // namespace ug
}  // namespace cee
