//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2021, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Vec3d.h"
#include "CeeUnstructGrid/Base.h"
#include <vector>

namespace cee {
namespace ug {
    
//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT ParticleTraceUtils
{
public:
    static std::vector<Vec3d> computeGridPoints(const Vec3d& center, const Vec3d& normal, unsigned int numU, unsigned int numV, double groupSpacing);
};

}  // namespace ug
}  // namespace cee
