//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2016, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeVisualization/OverlayItem.h"
#include "CeePlot2d/OverlayPlot.h"
#include "CeeCore/PtrRef.h"

namespace cee {
class PropertySetCollection;

namespace ug {
class DataSourceVTFx;


//==================================================================================================
//
// Create overlay plots from properties in a property set collection and the referenced data source
//
//==================================================================================================
class CEE_UG_EXPORT PropertyApplierPlot2d
{
public:
    PropertyApplierPlot2d(PropertySetCollection* propSetCollection, DataSourceVTFx* dataSource);
    ~PropertyApplierPlot2d();

    size_t plotCount() const;
    PtrRef<plt::OverlayPlot> createOverlayPlot(size_t plotIndex, vis::Font* font);

private:
    CEE_PRIVATE_IMPL(PropertyApplierPlot2d);
    CEE_DISALLOW_COPY_AND_ASSIGN(PropertyApplierPlot2d);
};

}  // namespace ug
}  // namespace cee
