//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Pimpl.h"
#include "CeeVisualization/View.h"
#include "CeeUnstructGrid/UnstructGridModel.h"

namespace cee {
class PropertySetCollection;
class ImageResources;

namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT PropertyBuilder
{
public:
    PropertyBuilder(PropertySetCollection* collection, ImageResources* resources);
    ~PropertyBuilder();

    bool addFromView(const cee::vis::View& view);
    bool addFromModel(const UnstructGridModel& model);

private:
    CEE_PRIVATE_IMPL(PropertyBuilder);
    CEE_DISALLOW_COPY_AND_ASSIGN(PropertyBuilder);
};


}  // namespace ug
}  // namespace cee
