//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2021, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Str.h"

namespace cee {
namespace ug {

//==================================================================================================
//
//
//
//==================================================================================================
class CEE_UG_EXPORT ResultCalculatorParams
{
public:
    ResultCalculatorParams();
    ~ResultCalculatorParams();
    
    bool                hasKey(const Str& key) const;
    double              value(const Str& key) const;
    void                setValue(const Str& key, double value);

    std::vector<Str>    keyArray() const;

private:
    CEE_PRIVATE_IMPL(ResultCalculatorParams);
    CEE_BASE_F(DataSourceInterface);
    
    CEE_DISALLOW_COPY_AND_ASSIGN(ResultCalculatorParams);
};

}  // namespace ug
}  // namespace cee
