//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2017, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Vec3d.h"
#include "CeeCore/SymmetricTensor.h"

#include <vector>

namespace cee {
namespace ug {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT ResultsQueryResult
{
public:
    ResultsQueryResult();
    ResultsQueryResult(const ResultsQueryResult& other);
    ~ResultsQueryResult();

    ResultsQueryResult& operator=(const ResultsQueryResult& other);
    bool operator==(const ResultsQueryResult& other) const;

    void                                setSpatialDimension(int spatialDimension);
    bool                                addSubItem(double* data, size_t dataCount);

    size_t                              subItemCount() const;

    double                              scalar() const; 
    Vec3d                               vector() const;
    SymmetricTensor                     tensor() const;

    double                              subItemScalar(size_t subItemIndex) const;
    Vec3d                               subItemVector(size_t subItemIndex) const;
    SymmetricTensor                     subItemTensor(size_t subItemIndex) const;

    double                              averageSubItemScalar() const;
    Vec3d                               averageSubItemVector() const;
    SymmetricTensor                     averageSubItemTensor() const;

private:

    CEE_PRIVATE_IMPL(ResultsQueryResult);
    //CEE_PRIVATE_F(ResultsQuery);

};


}  // namespace ug
}  // namespace cee
