//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2021, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once



#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Vec3d.h"
#include "CeeCore/SymmetricTensor.h"
#include "CeeCore/RefCountedObject.h"


namespace cee {
namespace ug {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT ResultsQueryResultPosition
{
public:
    ResultsQueryResultPosition();

    ~ResultsQueryResultPosition();
    ResultsQueryResultPosition(const ResultsQueryResultPosition& other);
    ResultsQueryResultPosition& operator=(const ResultsQueryResultPosition& other);

    bool operator==(const ResultsQueryResultPosition& other) const;

    void initialize(Vec3d position, const double* resultData, size_t dimension, int partId, int itemId, ResultMapping mapping);

    double          scalar() const;
    Vec3d           vector() const;
    SymmetricTensor tensor() const;

    const double*   rawValuePointer() const;
    void            setRawPointer(const double* resultData, size_t dataSize);

    size_t          resultSize() const;

    Vec3d           position() const;
    void            setPosition(const Vec3d& position);

    int             partId() const;
    void            setPartId(int partId);

    int             itemId() const;
    void            setItemId(int itemId);

    ResultMapping   mapping() const;
    void            setMapping(ResultMapping mapping) const;

    ResultType      type() const;

private:
    CEE_PRIVATE_IMPL(ResultsQueryResultPosition);
};


}  // namespace ug
}  // namespace cee
