//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/Str.h"

namespace cee {
namespace ug {


    
//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT SectionInfo
{
public:
    SectionInfo();
    SectionInfo(int id, const Str& name, int categoryId);
    SectionInfo(const SectionInfo& other);
    ~SectionInfo();

    SectionInfo& operator=(const SectionInfo& rhs);
    bool         operator==(const SectionInfo& rhs) const;
    bool         operator!=(const SectionInfo& rhs) const;

    int             id() const;
    Str             name() const;
    int             categoryId() const;

private:
    CEE_PRIVATE_IMPL(SectionInfo);
};


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT SectionCategoryInfo
{
public:
    SectionCategoryInfo();
    SectionCategoryInfo(int id, const Str& name);
    SectionCategoryInfo(const SectionCategoryInfo& other);
    ~SectionCategoryInfo();

    SectionCategoryInfo& operator=(const SectionCategoryInfo& rhs);
    bool         operator==(const SectionCategoryInfo& rhs) const;
    bool         operator!=(const SectionCategoryInfo& rhs) const;


    int             id() const;
    Str             name() const;
    

private:
    CEE_PRIVATE_IMPL(SectionCategoryInfo);
};


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT SectionGroupInfo
{
public:
    SectionGroupInfo();
    SectionGroupInfo(int id, const Str& name, const std::vector<int>& sectionIds);
    SectionGroupInfo(const SectionGroupInfo& other);
    ~SectionGroupInfo();

    SectionGroupInfo& operator=(const SectionGroupInfo& rhs);
    bool              operator==(const SectionGroupInfo& rhs) const;
    bool              operator!=(const SectionGroupInfo& rhs) const;


    int                       id() const;
    Str                       name() const;
    std::vector<int>          sectionIds() const;


private:
    CEE_PRIVATE_IMPL(SectionGroupInfo);
};

}  // namespace ug
}  // namespace cee
