//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2017, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/Str.h"

namespace cee {
namespace ug {



//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT SetInfo
{
public:
	SetInfo();
 	SetInfo(int id, const Str& name, const Str& description);
	SetInfo(const SetInfo& other);
	~SetInfo();

	SetInfo&			operator=(const SetInfo& rhs);
    bool                operator==(const SetInfo& rhs) const;
    bool                operator!=(const SetInfo& rhs) const;

    Str					name() const;
	void				setName(const Str& name);
    int                 id() const;
    Str                 description() const;
	void				setDescription(const Str& desc);

	bool                isValid() const;


private:
    CEE_PRIVATE_IMPL(SetInfo);
};


}  // namespace ug
}  // namespace cee
