//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeCore/Str.h"

namespace cee {
namespace ug {

//==================================================================================================
///
/// 
///
//==================================================================================================
class CEE_UG_EXPORT SimulationInfo
{

public:
    SimulationInfo();
    SimulationInfo(const SimulationInfo& other);
    ~SimulationInfo();

    SimulationInfo& operator=(const SimulationInfo& rhs);

    Str title() const;
    void setTitle(const Str& title);

    Str description() const;
    void setDescription(const Str& description);

    Str filename() const;
    void setFilename(const Str& filename);

    Str sourceFilename() const;
    void setSourceFilename(const Str& filename);

    SimulationType type() const;
    void setType(SimulationType type);

    SolutionType solutionType() const;
    void setSolutionType(SolutionType type);

private:
    CEE_PRIVATE_IMPL(SimulationInfo);
};


}  // namespace ug
}  // namespace cee
