//##################################################################################################
//
//  Ceetron Analyzer
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2019, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################


#pragma once

#include "CeeApp/Base.h"

#include "CeeCore/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Str.h"


namespace cee {

namespace ug {
    class Situation;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT SituationIo : public RefCountedObject
{
public:
    static bool readFolder(Situation* situation, const Str& folder);
    static bool writeFolder(const Situation* situation, const Str& folder);

    static bool readArchiveFile(Situation* situation, const Str& filename);
    static bool writeArchiveFile(const Situation* situation, const Str& filename);

private:
    SituationIo();
    virtual ~SituationIo();

private:
    CEE_PRIVATE_IMPL(SituationIo);
    CEE_DISALLOW_COPY_AND_ASSIGN(SituationIo);
};

}
}
