//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/Str.h"

namespace cee {
namespace ug {


    
//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT StateGroupInfo
{
public:
    StateGroupInfo();
    StateGroupInfo(int id, const Str& name);
    StateGroupInfo(const StateGroupInfo& other);
    ~StateGroupInfo();

    StateGroupInfo& operator=(const StateGroupInfo& rhs);

    int             id() const;
    Str             name() const;

    size_t          stateCount() const;
    int             stateId(size_t index) const;

    void            addStateId(int stateId);
    bool            hasStateId(int stateId) const;
    void            clear();

private:
    CEE_PRIVATE_IMPL(StateGroupInfo);
};

}  // namespace ug
}  // namespace cee
