//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2012, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/Str.h"

namespace cee {
namespace ug {


    
//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT StateInfo
{
public:
    StateInfo();
    StateInfo(int stateId, const Str& stateName, double stateRefVal);
    StateInfo(const StateInfo& other);
    ~StateInfo();

    StateInfo&      operator=(const StateInfo& rhs);
    bool            operator==(const StateInfo& rhs) const;
    bool            operator!=(const StateInfo& rhs) const;

    int             id() const;
    Str             name() const;
    double          referenceValue() const;

private:
    CEE_PRIVATE_IMPL(StateInfo);
};

}  // namespace ug
}  // namespace cee
