//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"

#include "CeeCore/RefCountedObject.h"

class VTFxZipMemFile;

namespace cee {
class Str;

namespace ug {

//==================================================================================================
//
// VTFx memory file
//
//==================================================================================================
class CEE_UG_EXPORT VTFxMemoryFile  : public RefCountedObject
{
public:
    VTFxMemoryFile();
    VTFxMemoryFile(const VTFxMemoryFile& other);
    virtual ~VTFxMemoryFile();
    
    VTFxMemoryFile& operator=(const VTFxMemoryFile& other);

    void            setFromRawData(unsigned char data[], size_t dataSizeInBytes);
    bool            save(const Str& filename) const;

    VTFxZipMemFile* internal_vtfxZipMemFile();
    const VTFxZipMemFile* internal_vtfxZipMemFile() const;

private:
    CEE_PRIVATE_IMPL(VTFxMemoryFile);
};

}  // namespace ug
}  // namespace cee
