//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2020, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeUnstructGrid/Base.h"
#include "CeeUnstructGrid/ParticleTraceData.h"
#include "CeeCore/Vec3d.h"

#include <vector>


namespace cee {
namespace ug {

class UnstructGridModel;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_UG_EXPORT VisualizationParticleTraceQuery
{
public:
    VisualizationParticleTraceQuery(const UnstructGridModel* model, size_t frameIndex, size_t geometryIndex);
    ~VisualizationParticleTraceQuery();
    
    size_t  groupCount();
    void    traceData(size_t groupIndex, std::vector<cee::ug::ParticleTraceData>* traceData);
   
private:
    CEE_PRIVATE_IMPL(VisualizationParticleTraceQuery);
    CEE_DISALLOW_COPY_AND_ASSIGN(VisualizationParticleTraceQuery);
};

}  // namespace ug
}  // namespace cee
