//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeCore/Color3f.h"

namespace cee {
namespace vis {


//==================================================================================================
//
// Background config
//
//==================================================================================================
class CEE_VIS_EXPORT Background
{
public:
    Background();
    Background(const Background& other);
    ~Background();

    Background& operator=(const Background& rhs);

    Color3f             topColor() const;
    Color3f             bottomColor() const;
    void                setSingleColor(const Color3f& color);
    void                setTopAndBottomColor(const Color3f& topColor, const Color3f& bottomColor);

    static Background   createSingleColor(const Color3f& color);
    static Background   createTopAndBottomColor(const Color3f& topColor, const Color3f& bottomColor);

private:
    CEE_PRIVATE_IMPL(Background);
};

} // namespace vis
} // namespace cee
