//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2013, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeCore/Vec3d.h"

namespace cee {
namespace vis {

class Camera;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT CameraAnimation
{
public:
    CameraAnimation(Camera* camera, const Vec3d& newPos, const Vec3d& newDir, const Vec3d& newUp);
    ~CameraAnimation();

    void setDuration(double seconds);
    void setTargetFieldOfViewYDegrees(double targetFOV);
    void setTargetOrthoHeight(double height);

    bool updateCamera();

private:
    CEE_PRIVATE_IMPL(CameraAnimation);
    CEE_DISALLOW_COPY_AND_ASSIGN(CameraAnimation);
};

} // namespace vis
} // namespace cee
