//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2014, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/Plane.h"

namespace cee {
class Ray;

namespace vis {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT Clipping : public RefCountedObject
{
public:
    virtual ~Clipping();

    size_t          planeCount() const;
    const Plane&    plane(size_t index) const;
    void            addPlane(const Plane& plane);
    void            setPlane(size_t index, const Plane& plane);
    void            removePlane(size_t index);
    void            removeAllPlanes();

    bool            mustBeBehindAllPlanesToClip() const;
    void            setMustBeBehindAllPlanesToClip(bool mustBeBehindAllToClip);

    void            setupRayDistancesFilters(Ray* ray) const;

private:
    Clipping();
    CEE_PRIVATE_F(View);
    CEE_PRIVATE_IMPL(Clipping);
    CEE_DISALLOW_COPY_AND_ASSIGN(Clipping);
};

} // namespace vis
} // namespace cee
