//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeCore/PtrRef.h"
#include "CeeCore/Str.h"

namespace cvf { class Font; }

namespace cee {
namespace vis {

//==================================================================================================
//
//
//
//==================================================================================================
class CEE_VIS_EXPORT Font : public RefCountedObject
{
public:
    virtual ~Font();

    virtual unsigned int pointSize() const;
    Str                  name() const;

    float                lineSpacing() const;
    void                 setLineSpacing(float factor);

    static PtrRef<Font>  createNormalFont();
    static PtrRef<Font>  createLargeFont();
    static PtrRef<Font>  createTrueTypeFont(const Str& filename, unsigned int pointSize);   // Deprecated, to be removed

protected:
    Font();

public:
    cvf::Font* internal_cvfFont();

private:
    CEE_PRIVATE_IMPL(Font);
    CEE_BASE_F(TrueTypeFont);
    CEE_DISALLOW_COPY_AND_ASSIGN(Font);
};

} // namespace vis
} // namespace cee
