//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeCore/Vec3d.h"

namespace cee {
namespace vis {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT MarkupModelHitItem
{
public:
    MarkupModelHitItem();

    size_t      partIndex() const;
    void        setPartIndex(size_t index);
    
    Vec3d       intersectionPoint() const;
    void        setIntersectionPoint(const Vec3d& intersectionPoint);

    size_t      partSubIndex() const;
    void        setPartSubIndex(size_t subIndex);
    
    double      distanceAlongRay() const;
    void        setDistanceAlongRay(double distance);

private:
    size_t      m_partIndex;
    Vec3d       m_intersectionPoint;
    size_t      m_partSubIndex;
    double      m_distanceAlongRay;
};

}  // namespace vis
}  // namespace cee
