//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: UnstructGrid
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"
#include "CeeCore/Pimpl.h"
#include "CeeVisualization/Base.h"
#include "CeeVisualization/MarkupModelHitItem.h"

namespace cee {
namespace vis {

//==================================================================================================
//
/// A collection of MarkupModelHitItem objects
//
//==================================================================================================
class CEE_VIS_EXPORT MarkupModelHitItemCollection
{
public:
    MarkupModelHitItemCollection();
    MarkupModelHitItemCollection(const MarkupModelHitItemCollection& other);
    virtual ~MarkupModelHitItemCollection();

    MarkupModelHitItemCollection& operator=(const MarkupModelHitItemCollection& other);
    
    size_t              count() const;
    MarkupModelHitItem  item(size_t index) const;
    void                add(const MarkupModelHitItem& item);

    MarkupModelHitItemCollection firstItems(double equalItemThreshold) const;

    
private:
    CEE_PRIVATE_IMPL(MarkupModelHitItemCollection);

};


}  // namespace vis
}  // namespace cee
