//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeCore/RefCountedObject.h"
#include "CeeVisualization/MarkupPart.h"
#include "CeeCore/Color3f.h"
#include "CeeCore/Str.h"
#include "CeeCore/Vec3d.h"
#include "CeeCore/PtrRef.h"

namespace cee {
namespace vis {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT MarkupText3dItem
{
public:
    Str     text;               ///< The text to draw. Support multi-line text with '\\n' as the line separator
    Vec3d   position;           ///< The position (in world coordinates) of the lower left corner of the text
    Vec3d   directionVector;    ///< The horizontal orientation (in world coordinates) of the text. The text 
                                ///  will be drawn in this direction. The vector does not need to be normalized.
    Vec3d   upVector;           ///< The up vector of the text to draw (in world coordinates). This is the vertical (y) 
                                ///  orientation of the text. The vector does not need to be normalized.
    double  textHeight;         ///< The height of the text (in world coordinate system) along the upVector.
                                ///  This will control the size of the text. As the height of each character is unique,
                                ///  the given height is the height of the letter A.

    MarkupText3dItem();
};

} // namespace vis
} // namespace cee
