//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeVisualization/OpenGLInfo.h"
#include "CeeCore/RefCountedObject.h"

namespace cvf {
class OpenGLContextGroup;
}

namespace cee {
namespace vis {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT OpenGLContextGroup : public RefCountedObject
{
public:
    virtual ~OpenGLContextGroup();

    size_t                      contextCount() const;
    OpenGLInfo                  info() const;

public:
    cvf::OpenGLContextGroup*    internal_cvfOpenGLContextGroup();

private:
    OpenGLContextGroup(cvf::OpenGLContextGroup* cvfContextGroup);

    CEE_BASE_F(VisualizationComponent);
    CEE_PRIVATE_IMPL(OpenGLContextGroup);
    CEE_DISALLOW_COPY_AND_ASSIGN(OpenGLContextGroup);
};

} // namespace vis
} // namespace cee
