//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"

#include "CeeCore/Str.h"

namespace cvf {
class OpenGLInfo;
}

namespace cee {
namespace vis {

    
//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT OpenGLInfo
{
public:
    OpenGLInfo();
    OpenGLInfo(Str version, Str vendor, Str renderer, Str backendDetails);
    OpenGLInfo(const OpenGLInfo& other);
    ~OpenGLInfo();

    OpenGLInfo& operator=(const OpenGLInfo& rhs);

    Str version() const;
    Str vendor() const;
    Str renderer() const;
    Str backendDetails() const;

private:
    CEE_PRIVATE_IMPL(OpenGLInfo);
};

}  // namespace vis
}  // namespace cee
