//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeVisualization/OverlayItem.h"

namespace cee {
class Color3f;
class Str;

namespace vis {
class Camera;
class Font;

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT OverlayAxisCross : public OverlayItem
{
public:
    OverlayAxisCross(Camera* camera, Font* font);
    virtual ~OverlayAxisCross();

    virtual unsigned int    width() const;
    virtual unsigned int    height() const;
    void                    setSize(unsigned int width, unsigned int height);

    virtual int             priority() const;
    virtual void            setPriority(int priority);

    Color3f                 textColor() const;
    void                    setTextColor(const Color3f& color);
    
    Str                     xAxisLabel() const;
    Str                     yAxisLabel() const;
    Str                     zAxisLabel() const;
    void                    setAxisLabels(const Str& xLabel, const Str& yLabel, const Str& zlabel);

    bool                    alwaysShowLabels() const;
    void                    setAlwaysShowLabels(bool alwaysShow);
    
private:
    virtual cvf::OverlayItem* internal_cvfOverlayItem();

private:
    CEE_PRIVATE_IMPL(OverlayAxisCross);
    CEE_DISALLOW_COPY_AND_ASSIGN(OverlayAxisCross);
};

} // namespace vis
} // namespace cee
