//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeVisualization/OverlayItem.h"
#include <string>

namespace cee {
class Image;

namespace vis {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT OverlayImage : public OverlayItem
{
public:
    enum Blending
    {
        NO_BLENDING,
        GLOBAL_ALPHA,
        TEXTURE_ALPHA
    };

public:
    OverlayImage();
    OverlayImage(Image* image);
    virtual ~OverlayImage();

    virtual unsigned int    width() const;
    virtual unsigned int    height() const;
    void                    setSize(unsigned int width, unsigned int height);

    virtual int             priority() const;
    virtual void            setPriority(int priority);

    const Image*            image() const;
    void                    setImage(Image* image);

    void                    setGlobalAlpha(float alpha);
    float                   globalAlpha() const;

    void                    setBlendingMode(Blending mode);
    Blending                blendingMode() const;

private:
    virtual cvf::OverlayItem* internal_cvfOverlayItem();

private:
    CEE_PRIVATE_IMPL(OverlayImage);
};

} // namespace vis
} // namespace cee
