//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"

namespace cee {
namespace vis {


//==================================================================================================
//
//
//
//==================================================================================================
class CEE_VIS_EXPORT TransparencyMode
{
public:
    enum Mode
    {
        AUTO,
        DEPTH_PEELING,
        DEPTH_PEELING_FRONT,
        WEIGHTED_AVERAGE,
        SIMPLE
    };

public:
    TransparencyMode();
    TransparencyMode(const TransparencyMode& other);
    ~TransparencyMode();

    TransparencyMode& operator=(const TransparencyMode& rhs);

    Mode                    mode() const;
    unsigned int            depthPeelingNumberOfPasses() const;

    static TransparencyMode createDepthPeeling(unsigned int numPasses);
    static TransparencyMode createDepthPeelingFront(unsigned int numPasses);
    static TransparencyMode createWeightedAverage();
    static TransparencyMode createSimple();
    static TransparencyMode createAuto();

private:
    CEE_PRIVATE_IMPL(TransparencyMode);
};

} // namespace vis
} // namespace cee
