//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2017, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeVisualization/Font.h"


namespace cee {
namespace vis {

//==================================================================================================
//
//
//
//==================================================================================================
class CEE_VIS_EXPORT TrueTypeFont : public Font
{
public:
    TrueTypeFont(const Str& filename, unsigned int pointSize);
    virtual ~TrueTypeFont();

    unsigned int pointSize() const;
    void         setPointSize(unsigned int size);

    bool         isLoaded() const;


private:
    TrueTypeFont();


private:
    CEE_DISALLOW_COPY_AND_ASSIGN(TrueTypeFont);
};

} // namespace vis
} // namespace cee
