//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"

namespace cvf {
    class OpenGLContext;
}

namespace cee {
namespace vis {


//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VIS_EXPORT Viewer
{
public:
    Viewer();
    virtual ~Viewer();

private:
    virtual void                internal_requestRedraw() = 0;
    virtual void                internal_requestImmediateRedraw() = 0;
    virtual bool                internal_makeOpenGLContextCurrent() = 0;
    virtual cvf::OpenGLContext* internal_cvfOpenGLContext() = 0;

private:
    CEE_PRIVATE_F(View);
    CEE_DISALLOW_COPY_AND_ASSIGN(Viewer);
};

} // namespace vis
} // namespace cee
