//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"
#include "CeeCore/Instance.h"
#include "CeeCore/PtrRef.h"
#include "CeeVisualization/OpenGLContextGroup.h"

#include <string>

namespace cvf {
class OpenGLFunctions;
}

namespace cee {

namespace vis {

class View;
class OpenGLFunctionsBackend;


//==================================================================================================
//
// Static class for Visualization component
//
//==================================================================================================
class CEE_VIS_EXPORT VisualizationComponent
{
public:
    static bool                         initialize(Instance* instance);
    static bool                         isInitialized();
    static bool                         isNoLicense();

    static unsigned int                 version();
    static Str                          versionString();

    static PtrRef<OpenGLContextGroup>   createOpenGLContextGroup();
    static PtrRef<OpenGLContextGroup>   createOpenGLContextGroup(OpenGLFunctionsBackend* functionsBackend);

public:
    static PtrRef<OpenGLContextGroup>   internal_createOpenGLContextGroupUsingCvfOpenGLFunctions(cvf::OpenGLFunctions* cvfOpenGLFunctions);
    static PtrRef<OpenGLContextGroup>   internal_createOpenGLContextGroupLimitedToFixedFunction();

private:
    VisualizationComponent();
    CEE_DISALLOW_COPY_AND_ASSIGN(VisualizationComponent);
};

} // namespace vis
} // namespace cee
