//##################################################################################################
//
//  Ceetron Desktop Components
//  Component: Visualization
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVisualization/Base.h"

#include "CeeVisualization/MouseEvent.h"

namespace cee {
namespace vis {

//==================================================================================================
//
// Wheel event
//
//==================================================================================================
class CEE_VIS_EXPORT WheelEvent : public MouseEvent
{
public:
    WheelEvent(int delta, int x, int y, MouseButtons buttonsDown, KeyboardModifiers modifiersDown);
    virtual ~WheelEvent();

    int delta() const;

private:
    int m_delta;    // The distance rotated, negative values indicate backward rotation, positive forward
};

} // namespace vis
} // namespace cee
